
class Generator:
  '''
  This interface handles decisions about which trees to generate
  '''
  
  def __init__(self, obj):
    '''
    This interface handles decisions about which trees to generate
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
