
class Flags:
  '''
  Interface for AST nodes with flags
  The only known flag is OP_DELETE
  '''
  
  def __init__(self, obj):
    '''
    Interface for AST nodes with flags
    The only known flag is OP_DELETE
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
