
class Vertex:
  '''
  A generic vertex is an Abstract Syntax Tree
  '''
  
  def __init__(self, obj):
    '''
    A generic vertex is an Abstract Syntax Tree
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
