#include <stdlib.h>

#ifndef included_ASE_Compiler_CompilerException_stub
#include <ASE/Compiler/CompilerException_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_CompilerException_CompilerException(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.CompilerException", _exception);
  }
  else
  {
    const struct ASE_Compiler_CompilerException__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_CompilerException__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.CompilerException", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

const char *ASE_Compiler_CompilerException_getMessage(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getMessage))(self->d_object, _exception);
}

void ASE_Compiler_CompilerException_setMessage(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *message, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setMessage))(self->d_object, message, _exception);
}

const char *ASE_Compiler_CompilerException_getStackTrace(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getStackTrace))(self->d_object, _exception);
}

void ASE_Compiler_CompilerException_addStackLine(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *line, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addStackLine))(self->d_object, line, _exception);
}

void ASE_Compiler_CompilerException_addStackEntry(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *filename, /*in*/ int32_t lineNumber, /*in*/ const char *methodName, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addStackEntry))(self->d_object, filename, lineNumber, methodName, _exception);
}

int32_t ASE_Compiler_CompilerException_getReferenceCount(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_CompilerException_addReference(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_CompilerException_deleteReference(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_CompilerException_isSame(struct ASE_Compiler_CompilerException__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_CompilerException_getClassName(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_CompilerException_getName(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_CompilerException_setName(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_CompilerException_isInstanceOf(struct ASE_Compiler_CompilerException__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_CompilerException_getSuper(struct ASE_Compiler_CompilerException__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}
