#ifndef included_ASE_Compiler_Cxx_ImplementationGenerator_stub
#define included_ASE_Compiler_Cxx_ImplementationGenerator_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Cxx_ImplementationGenerator
#include <ASE/Compiler/Cxx/ImplementationGenerator_IOR.h>
#endif

/* ASE.Compiler.Cxx.ImplementationGenerator.ImplementationGenerator: Constructor and cast method */
void *ASE_Compiler_Cxx_ImplementationGenerator_ImplementationGenerator(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.getSourceLanguages:  Retrieve the list of the languages in which ASTs are produced */
struct string__array *ASE_Compiler_Cxx_ImplementationGenerator_getSourceLanguages(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.setSourceLanguages:  Set the list of the languages in which ASTs are produced */
void ASE_Compiler_Cxx_ImplementationGenerator_setSourceLanguages(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct string__array *outputLanguages, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.getSource:  Retrieve the list of source ASTs for the given language
   Throw an exception if the language does not exist */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_ImplementationGenerator_getSource(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *language, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.setSource:  Set the list of source ASTs for the given language
   Throw an exception if the language does not exist */
void ASE_Compiler_Cxx_ImplementationGenerator_setSource(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.addSource:  Add to the list of source ASTs for the given language
   Throw an exception if the language does not exist */
void ASE_Compiler_Cxx_ImplementationGenerator_addSource(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Generator.removeSource:  Remove to the list of source ASTs for the given language
   Throw an exception if a vertex or language does not exist */
void ASE_Compiler_Cxx_ImplementationGenerator_removeSource(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *language, /*in*/ struct ASE_Compiler_Vertex__array *vertices, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_ImplementationGenerator_getRepository(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Cxx_ImplementationGenerator_setRepository(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitVertex(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitSpecification:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitSpecification(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Specification__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitPackage:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitPackage(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Package__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitType:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitType(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Type__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitTypeUniverse:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitTypeUniverse(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_TypeUniverse__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitEnumeration:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitEnumeration(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumeration__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitEnumerator:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitEnumerator(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Enumerator__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitArray:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitArray(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Array__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitInterface:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitInterface(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitParameter:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitParameter(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Parameter__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Visitor.visitMethod:  */
void ASE_Compiler_Cxx_ImplementationGenerator_visitMethod(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_Cxx_ImplementationGenerator_getReverseEdges(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_Cxx_ImplementationGenerator_setReverseEdges(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_Cxx_ImplementationGenerator_traverseVertex(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_Cxx_ImplementationGenerator_resetVertexNumbering(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_Cxx_ImplementationGenerator_discoverVertex(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_Cxx_ImplementationGenerator_finishVertex(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_ImplementationGenerator_getVerticesSeen(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_Cxx_ImplementationGenerator_setVerticesSeen(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_Cxx_ImplementationGenerator_getVertexSeen(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_Cxx_ImplementationGenerator_setVertexSeen(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Cxx_ImplementationGenerator_getReferenceCount(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Cxx_ImplementationGenerator_addReference(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Cxx_ImplementationGenerator_deleteReference(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Cxx_ImplementationGenerator_isSame(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Cxx_ImplementationGenerator_getClassName(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Cxx_ImplementationGenerator_getName(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Cxx_ImplementationGenerator_setName(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Cxx_ImplementationGenerator_isInstanceOf(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Cxx_ImplementationGenerator_getSuper(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.ImplementationGenerator.visitClass:  Each class becomes a source file including the methods and an implementation structure */
void ASE_Compiler_Cxx_ImplementationGenerator_visitClass(struct ASE_Compiler_Cxx_ImplementationGenerator__object *self, /*in*/ struct ASE_Compiler_SIDL_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
