#ifndef included_ASE_Compiler_Cxx_Printer_stub
#define included_ASE_Compiler_Cxx_Printer_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Cxx_Printer
#include <ASE/Compiler/Cxx/Printer_IOR.h>
#endif

/* ASE.Compiler.Cxx.Printer.Printer: Constructor and cast method */
void *ASE_Compiler_Cxx_Printer_Printer(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getTab:  Retrieve the tab string */
const char *ASE_Compiler_Cxx_Printer_getTab(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setTab:  Set the tab string */
void ASE_Compiler_Cxx_Printer_setTab(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getIndentSize:  Retrieve the number of tabs of the current indent */
int32_t ASE_Compiler_Cxx_Printer_getIndentSize(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setIndentSize:  Set the number of tabs of the current indent
   Throws an exception on a negative indent size */
void ASE_Compiler_Cxx_Printer_setIndentSize(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.increaseIndent:  Increase the index size by one */
void ASE_Compiler_Cxx_Printer_increaseIndent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.decreaseIndent:  Decrease the index size by one
   Throws an exception on a negative indent size */
void ASE_Compiler_Cxx_Printer_decreaseIndent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.indent:  Output the current indent (the indent size in tabs) */
void ASE_Compiler_Cxx_Printer_indent(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.write:  Output a string */
void ASE_Compiler_Cxx_Printer_write(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.println:  Output a string, properly indented and followed by a newline */
void ASE_Compiler_Cxx_Printer_println(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Printer_getRepository(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Cxx_Printer_setRepository(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Cxx_Printer_visitVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitSource:  */
void ASE_Compiler_Cxx_Printer_visitSource(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Source__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitHeader:  */
void ASE_Compiler_Cxx_Printer_visitHeader(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Header__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitPythonModule:  */
void ASE_Compiler_Cxx_Printer_visitPythonModule(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_PythonModule__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Visitor.visitExpression:  */
void ASE_Compiler_Cxx_Printer_visitExpression(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Expression__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_Cxx_Printer_getReverseEdges(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_Cxx_Printer_setReverseEdges(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_Cxx_Printer_traverseVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_Cxx_Printer_resetVertexNumbering(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_Cxx_Printer_discoverVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_Cxx_Printer_finishVertex(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Cxx_Printer_getVerticesSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_Cxx_Printer_setVerticesSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_Cxx_Printer_getVertexSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_Cxx_Printer_setVertexSeen(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Cxx_Printer_getReferenceCount(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Cxx_Printer_addReference(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Cxx_Printer_deleteReference(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Cxx_Printer_isSame(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Cxx_Printer_getClassName(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Cxx_Printer_getName(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Cxx_Printer_setName(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Cxx_Printer_isInstanceOf(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Cxx_Printer_getSuper(struct ASE_Compiler_Cxx_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitInclude:  */
void ASE_Compiler_Cxx_Printer_visitInclude(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Include__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDefine:  */
void ASE_Compiler_Cxx_Printer_visitDefine(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Define__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitMacro:  */
void ASE_Compiler_Cxx_Printer_visitMacro(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Macro__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitPreprocessorConditional:  */
void ASE_Compiler_Cxx_Printer_visitPreprocessorConditional(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_PreprocessorConditional__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitType:  */
void ASE_Compiler_Cxx_Printer_visitType(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Type__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitPointer:  */
void ASE_Compiler_Cxx_Printer_visitPointer(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Pointer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitStruct:  */
void ASE_Compiler_Cxx_Printer_visitStruct(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Struct__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitBitField:  */
void ASE_Compiler_Cxx_Printer_visitBitField(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_BitField__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitEnumeration:  */
void ASE_Compiler_Cxx_Printer_visitEnumeration(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumeration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitEnumerator:  */
void ASE_Compiler_Cxx_Printer_visitEnumerator(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Enumerator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitTypedef:  */
void ASE_Compiler_Cxx_Printer_visitTypedef(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Typedef__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitGroup:  */
void ASE_Compiler_Cxx_Printer_visitGroup(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Group__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDeclarator:  */
void ASE_Compiler_Cxx_Printer_visitDeclarator(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Declarator__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDeclaratorGroup:  */
void ASE_Compiler_Cxx_Printer_visitDeclaratorGroup(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_DeclaratorGroup__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitArray:  */
void ASE_Compiler_Cxx_Printer_visitArray(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Array__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitFunction:  */
void ASE_Compiler_Cxx_Printer_visitFunction(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Function__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitParameter:  */
void ASE_Compiler_Cxx_Printer_visitParameter(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Parameter__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDeclaration:  */
void ASE_Compiler_Cxx_Printer_visitDeclaration(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Declaration__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitStatement:  */
void ASE_Compiler_Cxx_Printer_visitStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Statement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitExpressionStatement:  */
void ASE_Compiler_Cxx_Printer_visitExpressionStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExpressionStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitCompoundStatement:  */
void ASE_Compiler_Cxx_Printer_visitCompoundStatement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_CompoundStatement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitIf:  */
void ASE_Compiler_Cxx_Printer_visitIf(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_If__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitSwitch:  */
void ASE_Compiler_Cxx_Printer_visitSwitch(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Switch__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitWhile:  */
void ASE_Compiler_Cxx_Printer_visitWhile(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_While__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitFor:  */
void ASE_Compiler_Cxx_Printer_visitFor(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_For__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitGoto:  */
void ASE_Compiler_Cxx_Printer_visitGoto(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Goto__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitContinue:  */
void ASE_Compiler_Cxx_Printer_visitContinue(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Continue__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitBreak:  */
void ASE_Compiler_Cxx_Printer_visitBreak(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Break__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitReturn:  */
void ASE_Compiler_Cxx_Printer_visitReturn(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Return__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitInitializer:  */
void ASE_Compiler_Cxx_Printer_visitInitializer(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Initializer__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAssignment:  */
void ASE_Compiler_Cxx_Printer_visitAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Assignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitInclusiveOrAssignment:  */
void ASE_Compiler_Cxx_Printer_visitInclusiveOrAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitExclusiveOrAssignment:  */
void ASE_Compiler_Cxx_Printer_visitExclusiveOrAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOrAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAndAssignment:  */
void ASE_Compiler_Cxx_Printer_visitAndAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_AndAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLeftShiftAssignment:  */
void ASE_Compiler_Cxx_Printer_visitLeftShiftAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitRightShiftAssignment:  */
void ASE_Compiler_Cxx_Printer_visitRightShiftAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShiftAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAdditionAssignment:  */
void ASE_Compiler_Cxx_Printer_visitAdditionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_AdditionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitSubtractionAssignment:  */
void ASE_Compiler_Cxx_Printer_visitSubtractionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_SubtractionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitMultiplicationAssignment:  */
void ASE_Compiler_Cxx_Printer_visitMultiplicationAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_MultiplicationAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDivisionAssignment:  */
void ASE_Compiler_Cxx_Printer_visitDivisionAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_DivisionAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitModuloAssignment:  */
void ASE_Compiler_Cxx_Printer_visitModuloAssignment(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ModuloAssignment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLogicalOr:  */
void ASE_Compiler_Cxx_Printer_visitLogicalOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLogicalAnd:  */
void ASE_Compiler_Cxx_Printer_visitLogicalAnd(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LogicalAnd__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitInclusiveOr:  */
void ASE_Compiler_Cxx_Printer_visitInclusiveOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_InclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitExclusiveOr:  */
void ASE_Compiler_Cxx_Printer_visitExclusiveOr(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ExclusiveOr__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAnd:  */
void ASE_Compiler_Cxx_Printer_visitAnd(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_And__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitEquality:  */
void ASE_Compiler_Cxx_Printer_visitEquality(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Equality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitInequality:  */
void ASE_Compiler_Cxx_Printer_visitInequality(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Inequality__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLessThan:  */
void ASE_Compiler_Cxx_Printer_visitLessThan(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitGreaterThan:  */
void ASE_Compiler_Cxx_Printer_visitGreaterThan(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThan__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLessThanOrEqual:  */
void ASE_Compiler_Cxx_Printer_visitLessThanOrEqual(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LessThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitGreaterThanOrEqual:  */
void ASE_Compiler_Cxx_Printer_visitGreaterThanOrEqual(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_GreaterThanOrEqual__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitLeftShift:  */
void ASE_Compiler_Cxx_Printer_visitLeftShift(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_LeftShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitRightShift:  */
void ASE_Compiler_Cxx_Printer_visitRightShift(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_RightShift__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAddition:  */
void ASE_Compiler_Cxx_Printer_visitAddition(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Addition__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitSubtraction:  */
void ASE_Compiler_Cxx_Printer_visitSubtraction(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Subtraction__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitMultiplication:  */
void ASE_Compiler_Cxx_Printer_visitMultiplication(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Multiplication__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitDivision:  */
void ASE_Compiler_Cxx_Printer_visitDivision(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Division__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitModulo:  */
void ASE_Compiler_Cxx_Printer_visitModulo(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Modulo__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitCast:  */
void ASE_Compiler_Cxx_Printer_visitCast(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Cast__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitSizeof:  */
void ASE_Compiler_Cxx_Printer_visitSizeof(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Sizeof__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitAddress:  */
void ASE_Compiler_Cxx_Printer_visitAddress(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Address__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitIndirection:  */
void ASE_Compiler_Cxx_Printer_visitIndirection(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Indirection__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitUnaryPlus:  */
void ASE_Compiler_Cxx_Printer_visitUnaryPlus(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryPlus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitUnaryMinus:  */
void ASE_Compiler_Cxx_Printer_visitUnaryMinus(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_UnaryMinus__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitComplement:  */
void ASE_Compiler_Cxx_Printer_visitComplement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Complement__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitNegation:  */
void ASE_Compiler_Cxx_Printer_visitNegation(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Negation__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitIncrement:  */
void ASE_Compiler_Cxx_Printer_visitIncrement(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Increment__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitStructReference:  */
void ASE_Compiler_Cxx_Printer_visitStructReference(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_StructReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitArrayReference:  */
void ASE_Compiler_Cxx_Printer_visitArrayReference(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_ArrayReference__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitFunctionCall:  */
void ASE_Compiler_Cxx_Printer_visitFunctionCall(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_FunctionCall__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitVariable:  */
void ASE_Compiler_Cxx_Printer_visitVariable(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Variable__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Cxx.Printer.visitConstant:  */
void ASE_Compiler_Cxx_Printer_visitConstant(struct ASE_Compiler_Cxx_Printer__object *self, /*in*/ struct ASE_Compiler_Cxx_Constant__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
