#ifndef included_ASE_Compiler_Output
#define included_ASE_Compiler_Output

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h>

/* These structures are used in this header */
struct ASE_Compiler_Output__object;

struct ASE_Compiler_Output__array;

struct ASE_BaseException__object;

struct ASE_BaseException__array;

#ifndef included_string
#include "string_IOR.h"
#endif

#ifndef included_int
#include "int_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_BaseException__object;

struct ASE_BaseException__array;

#ifndef included_ASE_Compiler_CodePurpose
#include "ASE/Compiler/CodePurpose_IOR.h"
#endif

#ifndef included_bool
#include "bool_IOR.h"
#endif

/* These structures are used in this header */
struct ASE_Compiler_Vertex__object;

struct ASE_Compiler_Vertex__array;

/* These structures are used in this header */
struct ASE_Compiler_Visitor__object;

struct ASE_Compiler_Visitor__array;

/* These structures are used in this header */
struct ASE_BaseInterface__object;

struct ASE_BaseInterface__array;

/* These structures are used in this header */
struct ASE_Compiler_CompilerException__object;

struct ASE_Compiler_CompilerException__array;

#ifndef included_ASE_Compiler_Visitor
#include "ASE/Compiler/Visitor_IOR.h"
#endif

/* The entry point vector (EPV) is the virtual function table for this interface */
struct ASE_Compiler_Output__epv {
  /* ASE.Compiler.Output.castObject: Builtin method */
  void *(*castObject)(struct ASE_Compiler_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.destroyObject: Builtin method */
  void (*destroyObject)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.strObject: Builtin method */
  const char *(*strObject)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
  int32_t (*getReferenceCount)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
  void (*addReference)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
  void (*deleteReference)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
  int (*isSame)(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
  const char *(*getClassName)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getName:  Retrieve the object name */
  const char *(*getName)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.setName:  Set the object name */
  void (*setName)(struct ASE_Compiler_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
  int (*isInstanceOf)(struct ASE_Compiler_Output__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
  struct ASE_BaseInterface__object *(*getSuper)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
  struct ASE_Compiler_Vertex__array *(*getRepository)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
  void (*setRepository)(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Visitor.visitVertex:  */
  void (*visitVertex)(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getDisableOutput:  Retrieve the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
  int (*getDisableOutput)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setDisableOutput:  Set the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
  void (*setDisableOutput)(struct ASE_Compiler_Output__object *self, /*in*/ int disableOutput, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getDisableSource:  Retrieve the flag to disable writing source
   Headers and other support files will still be output */
  int (*getDisableSource)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setDisableSource:  Set the flag to disable writing source
   Headers and other support files will still be output */
  void (*setDisableSource)(struct ASE_Compiler_Output__object *self, /*in*/ int disableSource, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
  const char *(*getRoot)(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
  void (*setRoot)(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*in*/ const char *root, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getIncludeDirectories:  Retrieve the list of include directories
   This seems general enough to include for all languages */
  struct string__array *(*getIncludeDirectories)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setIncludeDirectories:  Set the list of include directories
   This seems general enough to include for all languages */
  void (*setIncludeDirectories)(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getSystemIncludeDirectories:  Retrieve the list of system include directories
   This seems general enough to include for all languages */
  struct string__array *(*getSystemIncludeDirectories)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setSystemIncludeDirectories:  Set the list of system include directories
   This seems general enough to include for all languages */
  void (*setSystemIncludeDirectories)(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.getFiles:  Retrieve the list of output files */
  struct string__array *(*getFiles)(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);
  /* ASE.Compiler.Output.setFiles:  Set the list of output files */
  void (*setFiles)(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *files, /*out*/ struct ASE_BaseException__object **_exception);
};

/* The IOR object structure for this type */
struct ASE_Compiler_Output__object {
  struct ASE_Compiler_Visitor__object ase_compiler_visitor;
  struct ASE_Compiler_Output__epv *d_epv;
  struct ASE_Compiler_Output__epv *d_oldEpv;
  void *d_object;
};

/* The IOR array structure for this type */
struct ASE_Compiler_Output__array {
  struct ASE_Compiler_Output__object **d_firstElement;
  int32_t *d_lower;
  int32_t *d_upper;
  int32_t *d_stride;
  int d_borrowed;
  int32_t d_dimen;
};

/* The entry points into the DLL containing this type */
struct ASE_Compiler_Output__external {
  /* createArray: Create a dense array of the given dimension with specified index bounds
This array owns and manages its data
All object pointers are initialized to NULL */
  struct ASE_Compiler_Output__array *(*createArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*out*/ struct ASE_BaseException__object **_exception);
  /* borrowArray: Create an array using user-provided memory */
  struct ASE_Compiler_Output__array *(*borrowArray)(/*in*/ int32_t dimen, /*in*/ struct int__array *lower, /*in*/ struct int__array *upper, /*in*/ struct int__array *stride, /*in*/ void *first, /*out*/ struct ASE_BaseException__object **_exception);
  /* destroyArray: Destroy the array (NULL arrays are ignored) */
  void (*destroyArray)(/*in*/ struct ASE_Compiler_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getDimen: Return the number of dimensions in the array
If the array pointer is NULL, zero is returned */
  int32_t (*getDimen)(/*in*/ struct ASE_Compiler_Output__array *array, /*out*/ struct ASE_BaseException__object **_exception);
  /* getLower: Return the lower bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, zero is returned */
  int32_t (*getLower)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getUpper: Return the upper bound on dimension ind
If the array pointer is NULL or dimen is not a valid dimension, -1 is returned */
  int32_t (*getUpper)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ int32_t dimen, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_Output__object *(*getElement)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ struct int__array *indices, /*out*/ struct ASE_BaseException__object **_exception);
  /* getElement4: Get an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the return value is non-NULL, the client owns one reference to the object/interface
The client must decrement the reference count when done with the reference */
  struct ASE_Compiler_Output__object *(*getElement4)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ struct int__array *indices, /*in*/ struct ASE_Compiler_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception);
  /* setElement4: Set an element of a multi-dimensional array
This will use the indices provided up to the actual dimension of the array, ignoring extra indices
If the incoming value is non-NULL, this function will increment the reference code of the object/interface
If it is overwriting a non-NULL pointer, the reference count of the object/interface being overwritten will be decremented */
  void (*setElement4)(/*in*/ struct ASE_Compiler_Output__array *array, /*in*/ int32_t i1, /*in*/ int32_t i2, /*in*/ int32_t i3, /*in*/ int32_t i4, /*in*/ struct ASE_Compiler_Output__object *value, /*out*/ struct ASE_BaseException__object **_exception);
};

/* This function, called upon loading the DLL, returns a pointer to the static structure of DLL entry points */
const struct ASE_Compiler_Output__external *ASE_Compiler_Output__externals(void);

#ifdef __cplusplus
}
#endif
#endif
