#ifndef included_ASE_Compiler_Output_stub
#define included_ASE_Compiler_Output_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Output
#include <ASE/Compiler/Output_IOR.h>
#endif

/* ASE.Compiler.Output.Output: Constructor and cast method */
void *ASE_Compiler_Output_Output(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Output_getReferenceCount(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Output_addReference(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Output_deleteReference(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Output_isSame(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Output_getClassName(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Output_getName(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Output_setName(struct ASE_Compiler_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Output_isInstanceOf(struct ASE_Compiler_Output__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Output_getSuper(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Output_getRepository(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Output_setRepository(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Output_visitVertex(struct ASE_Compiler_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getDisableOutput:  Retrieve the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
int ASE_Compiler_Output_getDisableOutput(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setDisableOutput:  Set the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
void ASE_Compiler_Output_setDisableOutput(struct ASE_Compiler_Output__object *self, /*in*/ int disableOutput, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getDisableSource:  Retrieve the flag to disable writing source
   Headers and other support files will still be output */
int ASE_Compiler_Output_getDisableSource(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setDisableSource:  Set the flag to disable writing source
   Headers and other support files will still be output */
void ASE_Compiler_Output_setDisableSource(struct ASE_Compiler_Output__object *self, /*in*/ int disableSource, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
const char *ASE_Compiler_Output_getRoot(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
void ASE_Compiler_Output_setRoot(struct ASE_Compiler_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*in*/ const char *root, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getIncludeDirectories:  Retrieve the list of include directories
   This seems general enough to include for all languages */
struct string__array *ASE_Compiler_Output_getIncludeDirectories(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setIncludeDirectories:  Set the list of include directories
   This seems general enough to include for all languages */
void ASE_Compiler_Output_setIncludeDirectories(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getSystemIncludeDirectories:  Retrieve the list of system include directories
   This seems general enough to include for all languages */
struct string__array *ASE_Compiler_Output_getSystemIncludeDirectories(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setSystemIncludeDirectories:  Set the list of system include directories
   This seems general enough to include for all languages */
void ASE_Compiler_Output_setSystemIncludeDirectories(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getFiles:  Retrieve the list of output files */
struct string__array *ASE_Compiler_Output_getFiles(struct ASE_Compiler_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setFiles:  Set the list of output files */
void ASE_Compiler_Output_setFiles(struct ASE_Compiler_Output__object *self, /*in*/ struct string__array *files, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
