#ifndef included_ASE_Compiler_Printer_stub
#define included_ASE_Compiler_Printer_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Printer
#include <ASE/Compiler/Printer_IOR.h>
#endif

/* ASE.Compiler.Printer.Printer: Constructor and cast method */
void *ASE_Compiler_Printer_Printer(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Printer_getReferenceCount(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Printer_addReference(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Printer_deleteReference(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Printer_isSame(struct ASE_Compiler_Printer__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Printer_getClassName(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Printer_getName(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Printer_setName(struct ASE_Compiler_Printer__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Printer_isInstanceOf(struct ASE_Compiler_Printer__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Printer_getSuper(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Printer_getRepository(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Printer_setRepository(struct ASE_Compiler_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Printer_visitVertex(struct ASE_Compiler_Printer__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getTab:  Retrieve the tab string */
const char *ASE_Compiler_Printer_getTab(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setTab:  Set the tab string */
void ASE_Compiler_Printer_setTab(struct ASE_Compiler_Printer__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getIndentSize:  Retrieve the number of tabs of the current indent */
int32_t ASE_Compiler_Printer_getIndentSize(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setIndentSize:  Set the number of tabs of the current indent
   Throws an exception on a negative indent size */
void ASE_Compiler_Printer_setIndentSize(struct ASE_Compiler_Printer__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.increaseIndent:  Increase the index size by one */
void ASE_Compiler_Printer_increaseIndent(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.decreaseIndent:  Decrease the index size by one
   Throws an exception on a negative indent size */
void ASE_Compiler_Printer_decreaseIndent(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.indent:  Output the current indent (the indent size in tabs) */
void ASE_Compiler_Printer_indent(struct ASE_Compiler_Printer__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.write:  Output a string */
void ASE_Compiler_Printer_write(struct ASE_Compiler_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.println:  Output a string, properly indented and followed by a newline */
void ASE_Compiler_Printer_println(struct ASE_Compiler_Printer__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
