#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_CallFunc_stub
#include <ASE/Compiler/Python/CallFunc_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_CallFunc_CallFunc(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.CallFunc", _exception);
  }
  else
  {
    const struct ASE_Compiler_Python_CallFunc__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Python_CallFunc__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Python.CallFunc", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_CallFunc_clone(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_CallFunc_getIdentifier(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setIdentifier(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_Python_CallFunc_getAttributes(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setAttributes(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_Python_CallFunc_hasAttribute(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_Python_CallFunc_addAttribute(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_Python_CallFunc_deleteAttribute(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_Python_CallFunc_getAttribute(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_CallFunc_getParent(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setParent(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_CallFunc_getChildren(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setChildren(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_CallFunc_addChildren(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_CallFunc_removeChildren(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_Python_CallFunc_getLineNumber(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setLineNumber(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_Python_CallFunc_getComments(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setComments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_CallFunc_addComments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_CallFunc_removeComments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_Python_CallFunc_getReferenceCount(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_addReference(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_deleteReference(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_CallFunc_isSame(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_CallFunc_getClassName(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_CallFunc_getName(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setName(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_CallFunc_isInstanceOf(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_CallFunc_getSuper(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_accept(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_CallFunc_copy(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

struct ASE_Compiler_Python_Vertex__array *ASE_Compiler_Python_CallFunc_getArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getArguments))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__array *arguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setArguments))(self->d_object, arguments, _exception);
}

void ASE_Compiler_Python_CallFunc_addArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__array *arguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addArguments))(self->d_object, arguments, _exception);
}

void ASE_Compiler_Python_CallFunc_removeArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__array *arguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeArguments))(self->d_object, arguments, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_CallFunc_getOptionalArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getOptionalArguments))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setOptionalArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *optionalArguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setOptionalArguments))(self->d_object, optionalArguments, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_CallFunc_getKeywordArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getKeywordArguments))(self->d_object, _exception);
}

void ASE_Compiler_Python_CallFunc_setKeywordArguments(struct ASE_Compiler_Python_CallFunc__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *keywordArguments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setKeywordArguments))(self->d_object, keywordArguments, _exception);
}
