#include <stdlib.h>

#ifndef included_ASE_Compiler_Python_Function_stub
#include <ASE/Compiler/Python/Function_Stub.h>
#endif

#ifndef included_ASE_ASEException
#include <ASE/ASEException_IOR.h>
#endif

#ifndef included_ASE_Loader
#include <ASE/Loader_IOR.h>
#endif

void *ASE_Compiler_Python_Function_Function(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  if (obj)
  {
    return (*(obj->d_epv->castObject))(obj, "ASE.Compiler.Python.Function", _exception);
  }
  else
  {
    const struct ASE_Compiler_Python_Function__external *(*_extFunc)(void);
    
    _extFunc = (const struct ASE_Compiler_Python_Function__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(&_exception)->getClassMethodTable("ASE.Compiler.Python.Function", &_exception);
    return (*((*_extFunc)()->createObject))(_exception);
  }
}

const char *ASE_Compiler_Python_Function_getFlags(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getFlags))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setFlags(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *flags, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setFlags))(self->d_object, flags, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_Function_clone(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->clone))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_Function_getIdentifier(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getIdentifier))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setIdentifier(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setIdentifier))(self->d_object, identifier, _exception);
}

struct ASE_Compiler_Attribute__array *ASE_Compiler_Python_Function_getAttributes(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttributes))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setAttributes(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setAttributes))(self->d_object, attributes, _exception);
}

int ASE_Compiler_Python_Function_hasAttribute(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->hasAttribute))(self->d_object, name, _exception);
}

void ASE_Compiler_Python_Function_addAttribute(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addAttribute))(self->d_object, attribute, _exception);
}

void ASE_Compiler_Python_Function_deleteAttribute(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Attribute__object *ASE_Compiler_Python_Function_getAttribute(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getAttribute))(self->d_object, name, _exception);
}

struct ASE_Compiler_Vertex__object *ASE_Compiler_Python_Function_getParent(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getParent))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setParent(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setParent))(self->d_object, parent, _exception);
}

struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Function_getChildren(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getChildren))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setChildren(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_Function_addChildren(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addChildren))(self->d_object, children, _exception);
}

void ASE_Compiler_Python_Function_removeChildren(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeChildren))(self->d_object, children, _exception);
}

int32_t ASE_Compiler_Python_Function_getLineNumber(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getLineNumber))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setLineNumber(struct ASE_Compiler_Python_Function__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setLineNumber))(self->d_object, lineNumber, _exception);
}

struct ASE_Compiler_Comment__array *ASE_Compiler_Python_Function_getComments(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getComments))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setComments(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_Function_addComments(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addComments))(self->d_object, comments, _exception);
}

void ASE_Compiler_Python_Function_removeComments(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->removeComments))(self->d_object, comments, _exception);
}

int32_t ASE_Compiler_Python_Function_getReferenceCount(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getReferenceCount))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_addReference(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->addReference))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_deleteReference(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->deleteReference))(self->d_object, _exception);
}

int ASE_Compiler_Python_Function_isSame(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isSame))(self->d_object, obj, _exception);
}

const char *ASE_Compiler_Python_Function_getClassName(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getClassName))(self->d_object, _exception);
}

const char *ASE_Compiler_Python_Function_getName(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getName))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setName(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setName))(self->d_object, name, _exception);
}

int ASE_Compiler_Python_Function_isInstanceOf(struct ASE_Compiler_Python_Function__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->isInstanceOf))(self->d_object, typeName, _exception);
}

struct ASE_BaseInterface__object *ASE_Compiler_Python_Function_getSuper(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getSuper))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_accept(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Python_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->accept))(self->d_object, visitor, _exception);
}

struct ASE_Compiler_Python_Vertex__object *ASE_Compiler_Python_Function_copy(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->copy))(self->d_object, _exception);
}

struct string__array *ASE_Compiler_Python_Function_getArgumentNames(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getArgumentNames))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setArgumentNames(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct string__array *argumentNames, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setArgumentNames))(self->d_object, argumentNames, _exception);
}

struct ASE_Compiler_Python_Vertex__array *ASE_Compiler_Python_Function_getDefaults(struct ASE_Compiler_Python_Function__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return (*(self->d_epv->getDefaults))(self->d_object, _exception);
}

void ASE_Compiler_Python_Function_setDefaults(struct ASE_Compiler_Python_Function__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__array *defaults, /*out*/ struct ASE_BaseException__object **_exception)
{
  (*(self->d_epv->setDefaults))(self->d_object, defaults, _exception);
}
