#ifndef included_ASE_Compiler_Python_Output_stub
#define included_ASE_Compiler_Python_Output_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Python_Output
#include <ASE/Compiler/Python/Output_IOR.h>
#endif

/* ASE.Compiler.Python.Output.Output: Constructor and cast method */
void *ASE_Compiler_Python_Output_Output(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getDisableOutput:  Retrieve the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
int ASE_Compiler_Python_Output_getDisableOutput(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setDisableOutput:  Set the flag to disable writing to disk
   This is useful for generating the list of files which would have been output */
void ASE_Compiler_Python_Output_setDisableOutput(struct ASE_Compiler_Python_Output__object *self, /*in*/ int disableOutput, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getDisableSource:  Retrieve the flag to disable writing source
   Headers and other support files will still be output */
int ASE_Compiler_Python_Output_getDisableSource(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setDisableSource:  Set the flag to disable writing source
   Headers and other support files will still be output */
void ASE_Compiler_Python_Output_setDisableSource(struct ASE_Compiler_Python_Output__object *self, /*in*/ int disableSource, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
const char *ASE_Compiler_Python_Output_getRoot(struct ASE_Compiler_Python_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setRoot:  Retrieve the directory root for files generated for the given purpose
   The purpose can be stub, cartilage, IOR, skeleton, or implementation */
void ASE_Compiler_Python_Output_setRoot(struct ASE_Compiler_Python_Output__object *self, /*in*/ enum ASE_Compiler_CodePurpose__enum purpose, /*in*/ const char *root, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getIncludeDirectories:  Retrieve the list of include directories
   This seems general enough to include for all languages */
struct string__array *ASE_Compiler_Python_Output_getIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setIncludeDirectories:  Set the list of include directories
   This seems general enough to include for all languages */
void ASE_Compiler_Python_Output_setIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getSystemIncludeDirectories:  Retrieve the list of system include directories
   This seems general enough to include for all languages */
struct string__array *ASE_Compiler_Python_Output_getSystemIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setSystemIncludeDirectories:  Set the list of system include directories
   This seems general enough to include for all languages */
void ASE_Compiler_Python_Output_setSystemIncludeDirectories(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *dirs, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.getFiles:  Retrieve the list of output files */
struct string__array *ASE_Compiler_Python_Output_getFiles(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Output.setFiles:  Set the list of output files */
void ASE_Compiler_Python_Output_setFiles(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct string__array *files, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getTab:  Retrieve the tab string */
const char *ASE_Compiler_Python_Output_getTab(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setTab:  Set the tab string */
void ASE_Compiler_Python_Output_setTab(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *tab, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.getIndentSize:  Retrieve the number of tabs of the current indent */
int32_t ASE_Compiler_Python_Output_getIndentSize(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.setIndentSize:  Set the number of tabs of the current indent
   Throws an exception on a negative indent size */
void ASE_Compiler_Python_Output_setIndentSize(struct ASE_Compiler_Python_Output__object *self, /*in*/ int32_t indentSize, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.increaseIndent:  Increase the index size by one */
void ASE_Compiler_Python_Output_increaseIndent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.decreaseIndent:  Decrease the index size by one
   Throws an exception on a negative indent size */
void ASE_Compiler_Python_Output_decreaseIndent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.indent:  Output the current indent (the indent size in tabs) */
void ASE_Compiler_Python_Output_indent(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Printer.println:  Output a string, properly indented and followed by a newline */
void ASE_Compiler_Python_Output_println(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Output_getRepository(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Python_Output_setRepository(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Python_Output_visitVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getReverseEdges:  Retrieve the flag for reversing the orientation of edges in the traversal */
int ASE_Compiler_Python_Output_getReverseEdges(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setReverseEdges:  Set the flag for reversing the orientation of edges in the traversal */
void ASE_Compiler_Python_Output_setReverseEdges(struct ASE_Compiler_Python_Output__object *self, /*in*/ int reverseEdges, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.traverseVertex:  Traverse each edge of this vertex */
void ASE_Compiler_Python_Output_traverseVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.resetVertexNumbering:  Reset the vertex discovery and finish numbering */
void ASE_Compiler_Python_Output_resetVertexNumbering(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.discoverVertex:  Mark a vertex as discovered and increment the count */
void ASE_Compiler_Python_Output_discoverVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.finishVertex:  Mark a vertex as finished and increment the count */
void ASE_Compiler_Python_Output_finishVertex(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVerticesSeen:  Retrieve the list of vertices discovered */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Output_getVerticesSeen(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVerticesSeen:  Set the list of vertices discovered */
void ASE_Compiler_Python_Output_setVerticesSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__array *seen, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.getVertexSeen:  Retrieve the vertex discovery state */
int ASE_Compiler_Python_Output_getVertexSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Search.setVertexSeen:  Set the vertex discovery state */
void ASE_Compiler_Python_Output_setVertexSeen(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*in*/ int state, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Python_Output_getReferenceCount(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Python_Output_addReference(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Python_Output_deleteReference(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Python_Output_isSame(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Python_Output_getClassName(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Python_Output_getName(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Python_Output_setName(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Python_Output_isInstanceOf(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Python_Output_getSuper(struct ASE_Compiler_Python_Output__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAdd:  */
void ASE_Compiler_Python_Output_visitAdd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAnd:  */
void ASE_Compiler_Python_Output_visitAnd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssAttr:  */
void ASE_Compiler_Python_Output_visitAssAttr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssList:  */
void ASE_Compiler_Python_Output_visitAssList(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssName:  */
void ASE_Compiler_Python_Output_visitAssName(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssTuple:  */
void ASE_Compiler_Python_Output_visitAssTuple(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAssign:  */
void ASE_Compiler_Python_Output_visitAssign(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitAugAssign:  */
void ASE_Compiler_Python_Output_visitAugAssign(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitand:  */
void ASE_Compiler_Python_Output_visitBitand(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitor:  */
void ASE_Compiler_Python_Output_visitBitor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBitxor:  */
void ASE_Compiler_Python_Output_visitBitxor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitBreak:  */
void ASE_Compiler_Python_Output_visitBreak(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitCallFunc:  */
void ASE_Compiler_Python_Output_visitCallFunc(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitClass:  */
void ASE_Compiler_Python_Output_visitClass(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitCompare:  */
void ASE_Compiler_Python_Output_visitCompare(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitConst:  */
void ASE_Compiler_Python_Output_visitConst(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPyNone:  */
void ASE_Compiler_Python_Output_visitPyNone(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitContinue:  */
void ASE_Compiler_Python_Output_visitContinue(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDict:  */
void ASE_Compiler_Python_Output_visitDict(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDiscard:  */
void ASE_Compiler_Python_Output_visitDiscard(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitDiv:  */
void ASE_Compiler_Python_Output_visitDiv(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitEllipsis:  */
void ASE_Compiler_Python_Output_visitEllipsis(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFor:  */
void ASE_Compiler_Python_Output_visitFor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListCompFor:  */
void ASE_Compiler_Python_Output_visitListCompFor(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFunction:  */
void ASE_Compiler_Python_Output_visitFunction(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitLambda:  */
void ASE_Compiler_Python_Output_visitLambda(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitGetAttr:  */
void ASE_Compiler_Python_Output_visitGetAttr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitGlobal:  */
void ASE_Compiler_Python_Output_visitGlobal(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitIf:  */
void ASE_Compiler_Python_Output_visitIf(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListCompIf:  */
void ASE_Compiler_Python_Output_visitListCompIf(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitImport:  */
void ASE_Compiler_Python_Output_visitImport(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitFrom:  */
void ASE_Compiler_Python_Output_visitFrom(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitInvert:  */
void ASE_Compiler_Python_Output_visitInvert(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitKeyword:  */
void ASE_Compiler_Python_Output_visitKeyword(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitLeftShift:  */
void ASE_Compiler_Python_Output_visitLeftShift(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitList:  */
void ASE_Compiler_Python_Output_visitList(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitListComp:  */
void ASE_Compiler_Python_Output_visitListComp(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitMod:  */
void ASE_Compiler_Python_Output_visitMod(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitMul:  */
void ASE_Compiler_Python_Output_visitMul(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitName:  */
void ASE_Compiler_Python_Output_visitName(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitNot:  */
void ASE_Compiler_Python_Output_visitNot(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitOr:  */
void ASE_Compiler_Python_Output_visitOr(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPass:  */
void ASE_Compiler_Python_Output_visitPass(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPower:  */
void ASE_Compiler_Python_Output_visitPower(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPrint:  */
void ASE_Compiler_Python_Output_visitPrint(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitPrintnl:  */
void ASE_Compiler_Python_Output_visitPrintnl(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitRaise:  */
void ASE_Compiler_Python_Output_visitRaise(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitReturn:  */
void ASE_Compiler_Python_Output_visitReturn(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitRightShift:  */
void ASE_Compiler_Python_Output_visitRightShift(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSlice:  */
void ASE_Compiler_Python_Output_visitSlice(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitStmt:  */
void ASE_Compiler_Python_Output_visitStmt(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSub:  */
void ASE_Compiler_Python_Output_visitSub(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitSubscript:  */
void ASE_Compiler_Python_Output_visitSubscript(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTryExcept:  */
void ASE_Compiler_Python_Output_visitTryExcept(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTryFinally:  */
void ASE_Compiler_Python_Output_visitTryFinally(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitTuple:  */
void ASE_Compiler_Python_Output_visitTuple(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitUnaryAdd:  */
void ASE_Compiler_Python_Output_visitUnaryAdd(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitUnarySub:  */
void ASE_Compiler_Python_Output_visitUnarySub(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitWhile:  */
void ASE_Compiler_Python_Output_visitWhile(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.visitYield:  */
void ASE_Compiler_Python_Output_visitYield(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Printer.printDocComment:  */
void ASE_Compiler_Python_Output_printDocComment(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Vertex__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Output.visitModule:  */
void ASE_Compiler_Python_Output_visitModule(struct ASE_Compiler_Python_Output__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Output.write:  This is overridden to redirect output to a file */
void ASE_Compiler_Python_Output_write(struct ASE_Compiler_Python_Output__object *self, /*in*/ const char *s, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
