#ifndef included_ASE_Compiler_Python_Visitor_stub
#define included_ASE_Compiler_Python_Visitor_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_Python_Visitor
#include <ASE/Compiler/Python/Visitor_IOR.h>
#endif

/* ASE.Compiler.Python.Visitor.Visitor: Constructor and cast method */
void *ASE_Compiler_Python_Visitor_Visitor(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_Python_Visitor_getReferenceCount(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_Python_Visitor_addReference(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_Python_Visitor_deleteReference(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_Python_Visitor_isSame(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_Python_Visitor_getClassName(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_Python_Visitor_getName(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_Python_Visitor_setName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_Python_Visitor_isInstanceOf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_Python_Visitor_getSuper(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.getRepository:  Retrieve auxilliary ASTs */
struct ASE_Compiler_Vertex__array *ASE_Compiler_Python_Visitor_getRepository(struct ASE_Compiler_Python_Visitor__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.setRepository:  Set auxilliary ASTs */
void ASE_Compiler_Python_Visitor_setRepository(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__array *repository, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Visitor.visitVertex:  */
void ASE_Compiler_Python_Visitor_visitVertex(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Vertex__object *vertex, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAdd:  */
void ASE_Compiler_Python_Visitor_visitAdd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Add__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAnd:  */
void ASE_Compiler_Python_Visitor_visitAnd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_And__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAssAttr:  */
void ASE_Compiler_Python_Visitor_visitAssAttr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAssList:  */
void ASE_Compiler_Python_Visitor_visitAssList(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssList__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAssName:  */
void ASE_Compiler_Python_Visitor_visitAssName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssName__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAssTuple:  */
void ASE_Compiler_Python_Visitor_visitAssTuple(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AssTuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAssign:  */
void ASE_Compiler_Python_Visitor_visitAssign(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Assign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitAugAssign:  */
void ASE_Compiler_Python_Visitor_visitAugAssign(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_AugAssign__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitBitand:  */
void ASE_Compiler_Python_Visitor_visitBitand(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitand__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitBitor:  */
void ASE_Compiler_Python_Visitor_visitBitor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitBitxor:  */
void ASE_Compiler_Python_Visitor_visitBitxor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Bitxor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitBreak:  */
void ASE_Compiler_Python_Visitor_visitBreak(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Break__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitCallFunc:  */
void ASE_Compiler_Python_Visitor_visitCallFunc(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_CallFunc__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitClass:  */
void ASE_Compiler_Python_Visitor_visitClass(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Class__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitCompare:  */
void ASE_Compiler_Python_Visitor_visitCompare(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Compare__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitConst:  */
void ASE_Compiler_Python_Visitor_visitConst(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Const__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitPyNone:  */
void ASE_Compiler_Python_Visitor_visitPyNone(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_PyNone__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitContinue:  */
void ASE_Compiler_Python_Visitor_visitContinue(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Continue__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitDict:  */
void ASE_Compiler_Python_Visitor_visitDict(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Dict__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitDiscard:  */
void ASE_Compiler_Python_Visitor_visitDiscard(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Discard__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitDiv:  */
void ASE_Compiler_Python_Visitor_visitDiv(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Div__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitEllipsis:  */
void ASE_Compiler_Python_Visitor_visitEllipsis(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Ellipsis__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitFor:  */
void ASE_Compiler_Python_Visitor_visitFor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_For__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitListCompFor:  */
void ASE_Compiler_Python_Visitor_visitListCompFor(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompFor__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitFunction:  */
void ASE_Compiler_Python_Visitor_visitFunction(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Function__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitLambda:  */
void ASE_Compiler_Python_Visitor_visitLambda(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Lambda__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitGetAttr:  */
void ASE_Compiler_Python_Visitor_visitGetAttr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_GetAttr__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitGlobal:  */
void ASE_Compiler_Python_Visitor_visitGlobal(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Global__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitIf:  */
void ASE_Compiler_Python_Visitor_visitIf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_If__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitListCompIf:  */
void ASE_Compiler_Python_Visitor_visitListCompIf(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListCompIf__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitImport:  */
void ASE_Compiler_Python_Visitor_visitImport(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Import__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitFrom:  */
void ASE_Compiler_Python_Visitor_visitFrom(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_From__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitInvert:  */
void ASE_Compiler_Python_Visitor_visitInvert(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Invert__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitKeyword:  */
void ASE_Compiler_Python_Visitor_visitKeyword(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Keyword__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitLeftShift:  */
void ASE_Compiler_Python_Visitor_visitLeftShift(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_LeftShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitList:  */
void ASE_Compiler_Python_Visitor_visitList(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_List__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitListComp:  */
void ASE_Compiler_Python_Visitor_visitListComp(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_ListComp__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitMod:  */
void ASE_Compiler_Python_Visitor_visitMod(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mod__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitModule:  */
void ASE_Compiler_Python_Visitor_visitModule(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Module__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitMul:  */
void ASE_Compiler_Python_Visitor_visitMul(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Mul__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitName:  */
void ASE_Compiler_Python_Visitor_visitName(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Name__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitNot:  */
void ASE_Compiler_Python_Visitor_visitNot(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Not__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitOr:  */
void ASE_Compiler_Python_Visitor_visitOr(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Or__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitPass:  */
void ASE_Compiler_Python_Visitor_visitPass(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Pass__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitPower:  */
void ASE_Compiler_Python_Visitor_visitPower(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Power__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitPrint:  */
void ASE_Compiler_Python_Visitor_visitPrint(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Print__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitPrintnl:  */
void ASE_Compiler_Python_Visitor_visitPrintnl(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Printnl__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitRaise:  */
void ASE_Compiler_Python_Visitor_visitRaise(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Raise__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitReturn:  */
void ASE_Compiler_Python_Visitor_visitReturn(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Return__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitRightShift:  */
void ASE_Compiler_Python_Visitor_visitRightShift(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_RightShift__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitSlice:  */
void ASE_Compiler_Python_Visitor_visitSlice(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Slice__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitStmt:  */
void ASE_Compiler_Python_Visitor_visitStmt(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Stmt__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitSub:  */
void ASE_Compiler_Python_Visitor_visitSub(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Sub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitSubscript:  */
void ASE_Compiler_Python_Visitor_visitSubscript(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Subscript__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitTryExcept:  */
void ASE_Compiler_Python_Visitor_visitTryExcept(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryExcept__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitTryFinally:  */
void ASE_Compiler_Python_Visitor_visitTryFinally(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_TryFinally__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitTuple:  */
void ASE_Compiler_Python_Visitor_visitTuple(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Tuple__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitUnaryAdd:  */
void ASE_Compiler_Python_Visitor_visitUnaryAdd(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnaryAdd__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitUnarySub:  */
void ASE_Compiler_Python_Visitor_visitUnarySub(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_UnarySub__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitWhile:  */
void ASE_Compiler_Python_Visitor_visitWhile(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_While__object *node, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Python.Visitor.visitYield:  */
void ASE_Compiler_Python_Visitor_visitYield(struct ASE_Compiler_Python_Visitor__object *self, /*in*/ struct ASE_Compiler_Python_Yield__object *node, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
