#ifndef included_ASE_Compiler_SIDL_Interface_stub
#define included_ASE_Compiler_SIDL_Interface_stub

#ifdef __cplusplus
extern "C" {
#endif

#ifndef included_ASE_Compiler_SIDL_Interface
#include <ASE/Compiler/SIDL/Interface_IOR.h>
#endif

/* ASE.Compiler.SIDL.Interface.Interface: Constructor and cast method */
void *ASE_Compiler_SIDL_Interface_Interface(/*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.clone:  Return an empty object of the same type */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Interface_clone(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getIdentifier:  Retrieve the identifier associated with this vertex */
const char *ASE_Compiler_SIDL_Interface_getIdentifier(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setIdentifier:  Assign the identifier associated with this vertex */
void ASE_Compiler_SIDL_Interface_setIdentifier(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *identifier, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttributes:  Get attribute list for this element */
struct ASE_Compiler_Attribute__array *ASE_Compiler_SIDL_Interface_getAttributes(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setAttributes:  Set attribute list for this element */
void ASE_Compiler_SIDL_Interface_setAttributes(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Attribute__array *attributes, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.hasAttribute:  Determine whether an attribute is present on this vertex */
int ASE_Compiler_SIDL_Interface_hasAttribute(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addAttribute:  Add attribute to this vertex */
void ASE_Compiler_SIDL_Interface_addAttribute(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Attribute__object *attribute, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.deleteAttribute:  Remove an attribute on this vertex
   Throws an exception if the attribute does not exist */
void ASE_Compiler_SIDL_Interface_deleteAttribute(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getAttribute:  Get an attribute on this vertex
   Throws an exception if the attribute does not exist */
struct ASE_Compiler_Attribute__object *ASE_Compiler_SIDL_Interface_getAttribute(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getParent:  Retrieve the parent of this vertex */
struct ASE_Compiler_Vertex__object *ASE_Compiler_SIDL_Interface_getParent(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setParent:  Assign the parent of this vertex */
void ASE_Compiler_SIDL_Interface_setParent(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Vertex__object *parent, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getChildren:  Retrieve the children of this vertex */
struct ASE_Compiler_Vertex__array *ASE_Compiler_SIDL_Interface_getChildren(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setChildren:  Set the children of this vertex */
void ASE_Compiler_SIDL_Interface_setChildren(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addChildren:  Add children to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Interface_addChildren(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeChildren:  Remove children from this vertex
   Throws an exception if any child does not exist */
void ASE_Compiler_SIDL_Interface_removeChildren(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Vertex__array *children, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getLineNumber:  Retrieve the line number associated with this vertex */
int32_t ASE_Compiler_SIDL_Interface_getLineNumber(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setLineNumber:  Set the line number associated with this vertex */
void ASE_Compiler_SIDL_Interface_setLineNumber(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ int32_t lineNumber, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.getComments:  Retrieve the comments of this vertex */
struct ASE_Compiler_Comment__array *ASE_Compiler_SIDL_Interface_getComments(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.setComments:  Set the children of this vertex */
void ASE_Compiler_SIDL_Interface_setComments(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.addComments:  Add comments to this vertex (duplicates allowed) */
void ASE_Compiler_SIDL_Interface_addComments(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.Vertex.removeComments:  Remove comments from this vertex
   Throws an exception if a comment does not exist */
void ASE_Compiler_SIDL_Interface_removeComments(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_Comment__array *comments, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getReferenceCount:  Retrieve the intrinsic reference count of the underlying object */
int32_t ASE_Compiler_SIDL_Interface_getReferenceCount(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.addReference:  Add one to the intrinsic reference count of the underlying object
 - Objects continue to exist as long as the reference count is positive
 - Clients should call this method whenever they create another ongoing reference to an object or interface */
void ASE_Compiler_SIDL_Interface_addReference(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.deleteReference:  Decrease by one the intrinsic reference count of the underlying object
 - Delete the object if the reference count is non-positive
 - Clients should call this method whenever they remove a reference to an object or interface */
void ASE_Compiler_SIDL_Interface_deleteReference(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isSame:  Return true if and only if <code>obj</code> refers to the same underlying object as this object */
int ASE_Compiler_SIDL_Interface_isSame(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_BaseInterface__object *obj, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getClassName:  Return the type name of the underlying class object */
const char *ASE_Compiler_SIDL_Interface_getClassName(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getName:  Retrieve the object name */
const char *ASE_Compiler_SIDL_Interface_getName(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.setName:  Set the object name */
void ASE_Compiler_SIDL_Interface_setName(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.isInstanceOf:  Return <code>true</code> if this object is an instance of the specified type
 - This routine will return <code>true</code> if and only if a cast to the specified type would succeed */
int ASE_Compiler_SIDL_Interface_isInstanceOf(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ const char *typeName, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.BaseInterface.getSuper:  Retrieve an object with the parent interface
 IMPL: Obviously, this must be implemented in the IOR of each interface/class */
struct ASE_BaseInterface__object *ASE_Compiler_SIDL_Interface_getSuper(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.getDependencies:  Retrieve nodes on which this node depends */
struct ASE_Compiler_SIDL_Vertex__array *ASE_Compiler_SIDL_Interface_getDependencies(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.setDependencies:  Set nodes on which this node depends */
void ASE_Compiler_SIDL_Interface_setDependencies(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.addDependencies:  Add nodes on which this node depends */
void ASE_Compiler_SIDL_Interface_addDependencies(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Vertex.removeDependencies:  Remove nodes on which this node depends
   Throws an exception if a dependency does not exist */
void ASE_Compiler_SIDL_Interface_removeDependencies(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Vertex__array *dependencies, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.copy:  Need to override this */
struct ASE_Compiler_SIDL_Vertex__object *ASE_Compiler_SIDL_Interface_copy(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.getFullIdentifier:  Need to override this to calculate the fully qualified type name */
const char *ASE_Compiler_SIDL_Interface_getFullIdentifier(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.getBaseType:  Get flag indicating whether this is a base type */
int ASE_Compiler_SIDL_Interface_getBaseType(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Type.setBaseType:  Set flag indicating whether this is a base type */
void ASE_Compiler_SIDL_Interface_setBaseType(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ int baseType, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.accept:  Overridden to dispatch correctly */
void ASE_Compiler_SIDL_Interface_accept(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Visitor__object *visitor, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.getParents:  Retrieve the superinterfaces of this interface */
struct ASE_Compiler_SIDL_Interface__array *ASE_Compiler_SIDL_Interface_getParents(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.setParents:  Set the superinterfaces of this interface */
void ASE_Compiler_SIDL_Interface_setParents(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.addParents:  Add superinterfaces to this interface */
void ASE_Compiler_SIDL_Interface_addParents(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.removeParents:  Remove superinterfaces from this interface
   Throws an exception if a parent does not exist */
void ASE_Compiler_SIDL_Interface_removeParents(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Interface__array *parents, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.getMethods:  Retrieve the union of all methods supported by this interface */
struct ASE_Compiler_SIDL_Method__array *ASE_Compiler_SIDL_Interface_getMethods(struct ASE_Compiler_SIDL_Interface__object *self, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.setMethods:  Set the union of all methods supported by this interface */
void ASE_Compiler_SIDL_Interface_setMethods(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.addMethods:  Add to the union of all methods supported by this interface
   Method uniqueness is decided only the the method name, keeping the most recent one */
void ASE_Compiler_SIDL_Interface_addMethods(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception);

/* ASE.Compiler.SIDL.Interface.removeMethods:  Remove from the union of all methods supported by this interface
   Throws an exception if a method does not exist */
void ASE_Compiler_SIDL_Interface_removeMethods(struct ASE_Compiler_SIDL_Interface__object *self, /*in*/ struct ASE_Compiler_SIDL_Method__array *methods, /*out*/ struct ASE_BaseException__object **_exception);

#ifdef __cplusplus
}
#endif
#endif
