#!/usr/bin/env python
import user
import maker
import project

import os

class Make(maker.SIDLMake):
  def __init__(self):
    maker.SIDLMake.__init__(self)
    self.project = project.Project('bk://ase.bkbits.net/Compiler', self.getRoot())
    self.project.setWebDirectory('petsc@terra.mcs.anl.gov://mcs/www-unix/ase')
    self.clientLanguages = ['Python', 'Cxx']
    self.serverLanguages = ['Python']
    return

  def setupDependencies(self, sourceDB):
    '''Override this method to setup dependencies between source files'''
    maker.Make.setupDependencies(self, sourceDB)

    self.addDependency('bk://ase.bkbits.net/Runtime', 'ase.sidl')
#    self.sidl = [os.path.join('sidl', 'compiler.sidl'), os.path.join('sidl', 'sidl.sidl'), os.path.join('sidl', 'sidlVisitor.sidl'), os.path.join('sidl', 'python.sidl'), os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'bootstrap.sidl'), os.path.join('sidl', 'cxx.sidl'), os.path.join('sidl', 'cxxVisitor.sidl')]
    self.sidl = [os.path.join('sidl', 'compiler.sidl'), os.path.join('sidl', 'sidl.sidl'), os.path.join('sidl', 'sidlVisitor.sidl'), os.path.join('sidl', 'pythonI.sidl'), os.path.join('sidl', 'pythonII.sidl'), os.path.join('sidl', 'pythonIII.sidl'), os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'bootstrap.sidl'), os.path.join('sidl', 'cxxI.sidl'), os.path.join('sidl', 'cxxII.sidl'), os.path.join('sidl', 'cxxIII.sidl'), os.path.join('sidl', 'cxxIV.sidl'), os.path.join('sidl', 'cxxV.sidl'), os.path.join('sidl', 'cxxVisitor.sidl')]

##    # Must build python first, since the compiler is implemented in it
##    generator = os.path.join(self.project.getRoot(), 'sidl', 'python.sidl')
##    self.sidl.remove(generator)
##    self.sidl.insert(0, generator)
    sourceDB.addDependency(os.path.join('sidl', 'sidl.sidl'),          os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'sidlVisitor.sidl'),   os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'sidlVisitor.sidl'),   os.path.join('sidl', 'sidl.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'python.sidl'),        os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonI.sidl'),       os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonI.sidl'),       os.path.join('sidl', 'pythonII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonI.sidl'),       os.path.join('sidl', 'pythonIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonII.sidl'),      os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonII.sidl'),      os.path.join('sidl', 'pythonI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonII.sidl'),      os.path.join('sidl', 'pythonIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonIII.sidl'),     os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonIII.sidl'),     os.path.join('sidl', 'pythonI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonIII.sidl'),     os.path.join('sidl', 'pythonII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'sidl.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'sidlVisitor.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'pythonI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'pythonII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'pythonVisitor.sidl'), os.path.join('sidl', 'pythonIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'bootstrap.sidl'),     os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'bootstrap.sidl'),     os.path.join('sidl', 'sidl.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'bootstrap.sidl'),     os.path.join('sidl', 'sidlVisitor.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxx.sidl'),           os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxI.sidl'),          os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxI.sidl'),          os.path.join('sidl', 'cxxII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxI.sidl'),          os.path.join('sidl', 'cxxIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxI.sidl'),          os.path.join('sidl', 'cxxIV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxI.sidl'),          os.path.join('sidl', 'cxxV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxII.sidl'),         os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxII.sidl'),         os.path.join('sidl', 'cxxI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxII.sidl'),         os.path.join('sidl', 'cxxIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxII.sidl'),         os.path.join('sidl', 'cxxIV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxII.sidl'),         os.path.join('sidl', 'cxxV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIII.sidl'),        os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIII.sidl'),        os.path.join('sidl', 'cxxI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIII.sidl'),        os.path.join('sidl', 'cxxII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIII.sidl'),        os.path.join('sidl', 'cxxIV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIII.sidl'),        os.path.join('sidl', 'cxxV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIV.sidl'),         os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIV.sidl'),         os.path.join('sidl', 'cxxI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIV.sidl'),         os.path.join('sidl', 'cxxII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIV.sidl'),         os.path.join('sidl', 'cxxIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxIV.sidl'),         os.path.join('sidl', 'cxxV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxV.sidl'),          os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxV.sidl'),          os.path.join('sidl', 'cxxI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxV.sidl'),          os.path.join('sidl', 'cxxII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxV.sidl'),          os.path.join('sidl', 'cxxIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxV.sidl'),          os.path.join('sidl', 'cxxIV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'compiler.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'sidl.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'sidlVisitor.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'cxxI.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'cxxII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'cxxIII.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'cxxIV.sidl'))
    sourceDB.addDependency(os.path.join('sidl', 'cxxVisitor.sidl'),    os.path.join('sidl', 'cxxV.sidl'))
    return

  def buildPythonSkeleton(self, builder, sidlFile, language, generatedSource):
    if os.path.basename(sidlFile) == 'python.sidl':
      generatedSource.add(os.path.join(self.getSIDLServerDirectory(builder, sidlFile, language), 'SIDL_Python.c'))
      generatedSource.add(os.path.join(self.getSIDLServerDirectory(builder, sidlFile, language), 'SIDL_Python.h'))
    return maker.SIDLMake.buildPythonSkeleton(self, builder, sidlFile, language, generatedSource)

if __name__ ==  '__main__':
  Make().run()
