# Starting imports section
pass
import ASE.BaseClass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Parser
import ASE.Compiler.ParserException
import ASE.Compiler.Vertex
# Ending imports section
pass
import clex
import cparse
import ASE.Compiler.Cxx.cIncludeExpansion
# Starting static methods section
pass
# Ending static methods section
pass

class Parser:
  '''
  A Cxx parser
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.includeDirs = []
    self.systemIncludeDirs = []
    self.currentFile = 'Unknown'
  
  def parse(self, buf):
    '''
    Parse the buffer and return an AST object
    '''
    import ASE.Compiler.Cxx.Vertex
    self.holder = ASE.Compiler.Cxx.Vertex.Vertex()
    expander = ASE.Compiler.Cxx.cIncludeExpansion.IncludeExpander()
    expander.includeDirs = self.includeDirs
    expander.systemIncludeDirs = self.systemIncludeDirs
    expander.currentFile = self.currentFile
    cparse.setup()
    cparse.lexer = expander
    try:
      children = cparse.parser.parse(buf, lexer = expander)
    except Exception, e:
      import sys
      import traceback
      print e
      print traceback.print_tb(sys.exc_info()[2])
      raise RuntimeError('Bad parse')
    self.holder.setChildren(children)
    cparse.parser.restart()
    return self.holder
  
  def parseFile(self, filename):
    '''
    Parse the file and return an AST object
    '''
    f = file(filename)
    s = f.read()
    f.close()
    self.currentFile = filename
    self.holder = self.parse(s)
    self.currentFile = 'Unknown'
    if filename.endswith('.c'):
      import ASE.Compiler.CodePurpose
      import ASE.Compiler.Cxx.Source
      source = ASE.Compiler.Cxx.Source.Source()
      source.setFilename(filename)
      source.setChildren(self.holder.getChildren())
      source.setPurpose(ASE.Compiler.CodePurpose.STUB)
      self.holder = source
    elif filename.endswith('.h'):
      import ASE.Compiler.CodePurpose
      import ASE.Compiler.Cxx.Header
      header = ASE.Compiler.Cxx.Header.Header()
      header.setFilename(filename)
      header.setChildren(self.holder.getChildren())
      header.setPurpose(ASE.Compiler.CodePurpose.STUB)
      self.holder = header
    return self.holder
  
  def getIncludeDirectories(self):
    '''
    Retrieve the list of directories in which to look for included headers
    '''
    return self.includeDirs
  
  def setIncludeDirectories(self, includeDirs):
    '''
    Set the list of directories in which to look for included headers
    '''
    self.includeDirs = list(includeDirs)
  
  def getSystemIncludeDirectories(self):
    '''
    Retrieve the list of directories in which to look for included system headers
    '''
    return self.systemIncludeDirs
  
  def setSystemIncludeDirectories(self, includeDirs):
    '''
    Set the list of directories in which to look for included system headers
    '''
    self.systemIncludeDirs = list(includeDirs)
  # Ending class methods section
  pass
