# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Type:
  '''
  A C type
  Appendix A 8.2-4, K&R
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.baseType = 0
    self.isConst = 0
    self.isVolatile = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitType(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Type.Type()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.setBaseType(self.__IORself.getBaseType())
    root.setConst(self.__IORself.getConst())
    root.setVolatile(self.__IORself.getVolatile())
    root.addReference()
    return root
  
  def getBaseType(self):
    '''
    Retrieve flag indicating whether this is a base type
    '''
    return self.baseType
  
  def setBaseType(self, baseType):
    '''
    Set flag indicating whether this is a base type
    '''
    self.baseType = baseType
  
  def getConst(self):
    '''
    Retrieve the flag indicating whether this is a constant
    '''
    return self.isConst
  
  def setConst(self, isConst):
    '''
    Set the flag indicating whether this is a constant
    '''
    self.isConst = isConst
  
  def getVolatile(self):
    '''
    Retrieve the flag indicating whether this is volatile
    '''
    return self.isVolatile
  
  def setVolatile(self, isVolatile):
    '''
    Set the flag indicating whether this is volatile
    '''
    self.isVolatile = isVolatile
  # Ending class methods section
  pass
