# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Initializer
import ASE.Compiler.Cxx.Type
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Declarator:
  '''
  A C declarator
  Appendix A 8.5-7, K&R
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.type = None
    self.isStatic = 0
    self.isExtern = 0
    self.isTypedef = 0
    self.initializer = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitDeclarator(self.__IORself)
  
  def getType(self):
    '''
    Retrieve the declarator type
    '''
    return self.type
  
  def setType(self, type):
    '''
    Set the declarator type
    '''
    self.type = type
  
  def getStatic(self):
    '''
    Retrieve the flag for static storage (nonstatic storage is called automatic)
    '''
    return self.isStatic
  
  def setStatic(self, isStatic):
    '''
    Set the flag for static storage (nonstatic storage is called automatic)
    '''
    self.isStatic = isStatic
  
  def getExtern(self):
    '''
    Retrieve the flag for external linkage
    '''
    return self.isExtern
  
  def setExtern(self, isExtern):
    '''
    Set the flag for external linkage
    '''
    self.isExtern = isExtern
  
  def getTypedef(self):
    '''
    Retrieve the flag for a typedef
    '''
    return self.isTypedef
  
  def setTypedef(self, isTypedef):
    '''
    Set the flag for a typedef
    '''
    self.isTypedef = isTypedef
  
  def getInitializer(self):
    '''
    Retrieve the initializer
    '''
    return self.initializer
  
  def setInitializer(self, initializer):
    '''
    Set the initializer
    '''
    self.initializer = initializer
  # Ending class methods section
  pass
