# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.CompoundStatement
import ASE.Compiler.Cxx.Declarator
import ASE.Compiler.Cxx.Parameter
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Function:
  '''
  A C function
  The return type is given by getType()
  The child is the type modifier, which is just an identifier for normal functions (See K&R, A8.6.3)
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.parameters = []
    self.optionalArguments = 0
    self.body = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFunction(self.__IORself)
  
  def getParameters(self):
    '''
    Retrieve the parameters
    '''
    return self.parameters
  
  def setParameters(self, parameters):
    '''
    Set the parameters
    '''
    self.parameters = list(parameters)
  
  def addParameters(self, parameters):
    '''
    Add to the parameters
    '''
    self.parameters.extend(parameters)
  
  def removeParameters(self, parameters):
    '''
    Remove from the parameters
    Throw an exception if a parameter is not present
    '''
    for parameter in parameters:
      if parameter in self.parameters:
        self.parameters.remove(parameter)
      else:
        e = ASE.Compiler.CompilerException()
        e.setMessage('Parameter does not exist: ' + parameter.getIdentifier())
        raise e
  
  def getOptionalArguments(self):
    '''
    Retrieve the flag for optional arguments (a trailing ...)
    '''
    return self.optionalArguments
  
  def setOptionalArguments(self, optionalArguments):
    '''
    Set the flag for optional arguments (a trailing ...)
    '''
    self.optionalArguments = optionalArguments
  
  def getBody(self):
    '''
    Retrieve the function body, which is absent for declarations
    '''
    return self.body
  
  def setBody(self, body):
    '''
    Set the function body, which is absent for declarations
    '''
    self.body = body
  # Ending class methods section
  pass
