# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Declarator
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Cast:
  '''
  A C cast expression
  The child is the expression being cast
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.typeName = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitCast(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Cast.Cast()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    if not self.__IORself.getTypeName() is None:
      root.setTypeName(self.__IORself.getTypeName())
    root.addReference()
    return root
  
  def getTypeName(self):
    '''
    Retrieve the type being cast to
    '''
    return self.typeName
  
  def setTypeName(self, typeName):
    '''
    Set the type being cast to
    '''
    self.typeName = typeName
  # Ending class methods section
  pass
