# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class FunctionCall:
  '''
  A C function call expression
  The child is the function expression
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.arguments = []
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFunctionCall(self.__IORself)
  
  def getArguments(self):
    '''
    Retrieve the argument list
    '''
    return self.arguments
  
  def setArguments(self, arguments):
    '''
    Set the argument list
    '''
    self.arguments = list(arguments)
  
  def addArguments(self, arguments):
    '''
    Add to the argument list
    '''
    self.arguments.extend(arguments)
  
  def removeArguments(self, arguments):
    '''
    Remove from the argument list
    Throw an exception if an argument is not present
    '''
    for argument in arguments:
      if argument in self.arguments:
        self.arguments.remove(argument)
      else:
        e = ASE.Compiler.CompilerException()
        e.setMessage('Argument does not exist: ' + argument.getIdentifier())
        raise e
  # Ending class methods section
  pass
