# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class StructReference:
  '''
  A C structure reference expression
  The child is the structure being referenced
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.member = None
    self.isPointer = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitStructReference(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.StructReference.StructReference()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    root.setMember(self.__IORself.getMember())
    root.setPointer(self.__IORself.getPointer())
    root.addReference()
    return root
  
  def getMember(self):
    '''
    Retrieve the structure member which is being referenced
    '''
    return self.member
  
  def setMember(self, member):
    '''
    Set the structure member which is being referenced
    '''
    self.member = member
  
  def getPointer(self):
    '''
    Retrieve the flag indicating the reference to a structure pointer
    '''
    return self.isPointer
  
  def setPointer(self, isPointer):
    '''
    Set the flag indicating the reference to a structure pointer
    '''
    self.isPointer = isPointer
  # Ending class methods section
  pass
