# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class If:
  '''
  A C if statement
  The children are the true and false branches
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.branch = None
    self.isTernary = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitIf(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.If.If()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    if not self.__IORself.getBranch() is None:
      root.getBranch(self.__IORself.getBranch())
    root.setTernary(self.__IORself.getTernary())
    root.addReference()
    return root
  
  def getBranch(self):
    '''
    Retrieve the branch expression
    '''
    return self.branch
  
  def setBranch(self, branch):
    '''
    Set the branch expression
    '''
    self.branch = branch
  
  def getTernary(self):
    '''
    Retrieve the flag for a ternary operator form
    '''
    return self.isTernary
  
  def setTernary(self, isTernary):
    '''
    Set the flag for a ternary operator form
    '''
    self.isTernary = isTernary
  # Ending class methods section
  pass
