# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Statement:
  '''
  A C statement
  If the statement is labeled, the label is set as the identifier unless it is a case expression
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.caseLabel = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitStatement(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Statement.Statement()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    if not self.__IORself.getCaseLabel() is None:
      root.setCaseLabel(self.__IORself.getCaseLabel())
    root.addReference()
    return root
  
  def getCaseLabel(self):
    '''
    Retrieve the case label, if it exists
    '''
    return self.caseLabel
  
  def setCaseLabel(self, caseLabel):
    '''
    Set the case label
    '''
    self.caseLabel = caseLabel
  # Ending class methods section
  pass
