# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Vertex
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class While:
  '''
  A C while statement
  The child is the iteration statement
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.branch = None
    self.isDoWhile = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitWhile(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Variable.Variable()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [child.deleteReference() for child in root.getChildren()]
    if not self.__IORself.getBranch() is None:
      root.setBranch(self.__IORself.getBranch())
    root.setDoWhile(self.__IORself.getDoWhile())
    root.addReference()
    return root
  
  def getBranch(self):
    '''
    Retrieve the branch expression
    '''
    return self.branch
  
  def setBranch(self, branch):
    '''
    Set the branch expression
    '''
    self.branch = branch
  
  def getDoWhile(self):
    '''
    Retrieve the flag for a do-while statement
    '''
    return self.isDoWhile
  
  def setDoWhile(self, isDoWhile):
    '''
    Set the flag for a do-while statement
    '''
    self.isDoWhile = isDoWhile
  # Ending class methods section
  pass
