# Starting imports section
pass
import ASE.BaseClass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Addition
import ASE.Compiler.Cxx.AdditionAssignment
import ASE.Compiler.Cxx.Address
import ASE.Compiler.Cxx.And
import ASE.Compiler.Cxx.AndAssignment
import ASE.Compiler.Cxx.Array
import ASE.Compiler.Cxx.ArrayReference
import ASE.Compiler.Cxx.Assignment
import ASE.Compiler.Cxx.BitField
import ASE.Compiler.Cxx.Break
import ASE.Compiler.Cxx.Cast
import ASE.Compiler.Cxx.Complement
import ASE.Compiler.Cxx.CompoundStatement
import ASE.Compiler.Cxx.Constant
import ASE.Compiler.Cxx.Continue
import ASE.Compiler.Cxx.Declaration
import ASE.Compiler.Cxx.Declarator
import ASE.Compiler.Cxx.DeclaratorGroup
import ASE.Compiler.Cxx.Define
import ASE.Compiler.Cxx.Division
import ASE.Compiler.Cxx.DivisionAssignment
import ASE.Compiler.Cxx.Enumeration
import ASE.Compiler.Cxx.Enumerator
import ASE.Compiler.Cxx.Equality
import ASE.Compiler.Cxx.ExclusiveOr
import ASE.Compiler.Cxx.ExclusiveOrAssignment
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.ExpressionStatement
import ASE.Compiler.Cxx.For
import ASE.Compiler.Cxx.Function
import ASE.Compiler.Cxx.FunctionCall
import ASE.Compiler.Cxx.Goto
import ASE.Compiler.Cxx.GreaterThan
import ASE.Compiler.Cxx.GreaterThanOrEqual
import ASE.Compiler.Cxx.Group
import ASE.Compiler.Cxx.Header
import ASE.Compiler.Cxx.If
import ASE.Compiler.Cxx.Include
import ASE.Compiler.Cxx.InclusiveOr
import ASE.Compiler.Cxx.InclusiveOrAssignment
import ASE.Compiler.Cxx.Increment
import ASE.Compiler.Cxx.Indirection
import ASE.Compiler.Cxx.Inequality
import ASE.Compiler.Cxx.Initializer
import ASE.Compiler.Cxx.LeftShift
import ASE.Compiler.Cxx.LeftShiftAssignment
import ASE.Compiler.Cxx.LessThan
import ASE.Compiler.Cxx.LessThanOrEqual
import ASE.Compiler.Cxx.LogicalAnd
import ASE.Compiler.Cxx.LogicalOr
import ASE.Compiler.Cxx.Macro
import ASE.Compiler.Cxx.Modulo
import ASE.Compiler.Cxx.ModuloAssignment
import ASE.Compiler.Cxx.Multiplication
import ASE.Compiler.Cxx.MultiplicationAssignment
import ASE.Compiler.Cxx.Negation
import ASE.Compiler.Cxx.Parameter
import ASE.Compiler.Cxx.Pointer
import ASE.Compiler.Cxx.PreprocessorConditional
import ASE.Compiler.Cxx.PythonModule
import ASE.Compiler.Cxx.Return
import ASE.Compiler.Cxx.RightShift
import ASE.Compiler.Cxx.RightShiftAssignment
import ASE.Compiler.Cxx.Sizeof
import ASE.Compiler.Cxx.Source
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Struct
import ASE.Compiler.Cxx.StructReference
import ASE.Compiler.Cxx.Subtraction
import ASE.Compiler.Cxx.SubtractionAssignment
import ASE.Compiler.Cxx.Switch
import ASE.Compiler.Cxx.Type
import ASE.Compiler.Cxx.Typedef
import ASE.Compiler.Cxx.UnaryMinus
import ASE.Compiler.Cxx.UnaryPlus
import ASE.Compiler.Cxx.Variable
import ASE.Compiler.Cxx.Visitor
import ASE.Compiler.Cxx.While
import ASE.Compiler.Search
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class DepthFirstVisitor:
  '''
  Traverses the AST in a depth first manner
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.repository = []
    self.seen = []
    self.reverseEdges = 0
    self.vertexNumber = 0
  
  def getRepository(self):
    '''
    Retrieve auxilliary ASTs
    '''
    return self.repository
  
  def setRepository(self, repository):
    '''
    Set auxilliary ASTs
    '''
    self.repository = repository
  
  def visitVertex(self, vertex):
    self.discoverVertex(vertex)
    self.__IORself.traverseVertex(vertex)
    self.finishVertex(vertex)
  
  def visitSource(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitHeader(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitPythonModule(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitInclude(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDefine(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitMacro(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitPreprocessorConditional(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitType(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitPointer(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitStruct(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitBitField(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitEnumeration(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitEnumerator(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitTypedef(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitGroup(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDeclarator(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDeclaratorGroup(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitArray(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitFunction(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitParameter(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDeclaration(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitStatement(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitExpressionStatement(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitCompoundStatement(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitIf(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitSwitch(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitWhile(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitFor(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitGoto(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitContinue(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitBreak(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitReturn(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitInitializer(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitExpression(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitInclusiveOrAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitExclusiveOrAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAndAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLeftShiftAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitRightShiftAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAdditionAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitSubtractionAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitMultiplicationAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDivisionAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitModuloAssignment(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLogicalOr(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLogicalAnd(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitInclusiveOr(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitExclusiveOr(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAnd(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitEquality(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitInequality(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLessThan(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitGreaterThan(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLessThanOrEqual(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitGreaterThanOrEqual(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitLeftShift(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitRightShift(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAddition(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitSubtraction(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitMultiplication(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitDivision(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitModulo(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitCast(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitSizeof(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitAddress(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitIndirection(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitUnaryPlus(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitUnaryMinus(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitComplement(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitNegation(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitIncrement(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitStructReference(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitArrayReference(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitFunctionCall(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitVariable(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def visitConstant(self, vertex):
    self.__IORself.visitVertex(vertex)
  
  def getReverseEdges(self):
    '''
    Retrieve the flag for reversing the orientation of edges in the traversal
    '''
    return self.reverseEdges
  
  def setReverseEdges(self, reverseEdges):
    '''
    Set the flag for reversing the orientation of edges in the traversal
    '''
    self.reverseEdges = reverseEdges
  
  def traverseVertex(self, vertex):
    '''
    Traverse each edge of this vertex
    '''
    self.__IORself.setVertexSeen(vertex, 1)
    if self.__IORself.getReverseEdges():
      neighbors = [vertex.getParent()]
    else:
      neighbors = vertex.getChildren()
    for neighbor in neighbors:
      neighbor.accept(self.__IORself)
  
  def resetVertexNumbering(self):
    '''
    Reset the vertex discovery and finish numbering
    '''
    self.vertexNumber = 0
  
  def discoverVertex(self, vertex):
    '''
    Mark a vertex as discovered and increment the count
    '''
    self.vertexNumber += 1
  
  def finishVertex(self, vertex):
    '''
    Mark a vertex as finished and increment the count
    '''
    self.vertexNumber += 1
  
  def getVerticesSeen(self):
    '''
    Retrieve the list of vertices discovered
    '''
    return self.seen
  
  def setVerticesSeen(self, seen):
    '''
    Set the list of vertices discovered
    '''
    self.seen = list(seen)
  
  def getVertexSeen(self, vertex):
    '''
    Retrieve the vertex discovery state
    '''
    return vertex in self.seen
  
  def setVertexSeen(self, vertex, state):
    '''
    Set the vertex discovery state
    '''
    if state:
      if not vertex in self.seen:
        self.seen.append(vertex)
    else:
      if vertex in self.seen:
        self.seen.remove(vertex)
  # Ending class methods section
  pass
