# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.CodePurpose
import ASE.Compiler.CompilerException
import ASE.Compiler.Cxx.Addition
import ASE.Compiler.Cxx.AdditionAssignment
import ASE.Compiler.Cxx.Address
import ASE.Compiler.Cxx.And
import ASE.Compiler.Cxx.AndAssignment
import ASE.Compiler.Cxx.Array
import ASE.Compiler.Cxx.ArrayReference
import ASE.Compiler.Cxx.Assignment
import ASE.Compiler.Cxx.BitField
import ASE.Compiler.Cxx.Break
import ASE.Compiler.Cxx.Cast
import ASE.Compiler.Cxx.Complement
import ASE.Compiler.Cxx.CompoundStatement
import ASE.Compiler.Cxx.Constant
import ASE.Compiler.Cxx.Continue
import ASE.Compiler.Cxx.Declaration
import ASE.Compiler.Cxx.Declarator
import ASE.Compiler.Cxx.DeclaratorGroup
import ASE.Compiler.Cxx.Define
import ASE.Compiler.Cxx.Division
import ASE.Compiler.Cxx.DivisionAssignment
import ASE.Compiler.Cxx.Enumeration
import ASE.Compiler.Cxx.Enumerator
import ASE.Compiler.Cxx.Equality
import ASE.Compiler.Cxx.ExclusiveOr
import ASE.Compiler.Cxx.ExclusiveOrAssignment
import ASE.Compiler.Cxx.Expression
import ASE.Compiler.Cxx.ExpressionStatement
import ASE.Compiler.Cxx.For
import ASE.Compiler.Cxx.Function
import ASE.Compiler.Cxx.FunctionCall
import ASE.Compiler.Cxx.Goto
import ASE.Compiler.Cxx.GreaterThan
import ASE.Compiler.Cxx.GreaterThanOrEqual
import ASE.Compiler.Cxx.Group
import ASE.Compiler.Cxx.Header
import ASE.Compiler.Cxx.If
import ASE.Compiler.Cxx.Include
import ASE.Compiler.Cxx.InclusiveOr
import ASE.Compiler.Cxx.InclusiveOrAssignment
import ASE.Compiler.Cxx.Increment
import ASE.Compiler.Cxx.Indirection
import ASE.Compiler.Cxx.Inequality
import ASE.Compiler.Cxx.Initializer
import ASE.Compiler.Cxx.LeftShift
import ASE.Compiler.Cxx.LeftShiftAssignment
import ASE.Compiler.Cxx.LessThan
import ASE.Compiler.Cxx.LessThanOrEqual
import ASE.Compiler.Cxx.LogicalAnd
import ASE.Compiler.Cxx.LogicalOr
import ASE.Compiler.Cxx.Macro
import ASE.Compiler.Cxx.Modulo
import ASE.Compiler.Cxx.ModuloAssignment
import ASE.Compiler.Cxx.Multiplication
import ASE.Compiler.Cxx.MultiplicationAssignment
import ASE.Compiler.Cxx.Negation
import ASE.Compiler.Cxx.Parameter
import ASE.Compiler.Cxx.Pointer
import ASE.Compiler.Cxx.PreprocessorConditional
import ASE.Compiler.Cxx.Printer
import ASE.Compiler.Cxx.PythonModule
import ASE.Compiler.Cxx.Return
import ASE.Compiler.Cxx.RightShift
import ASE.Compiler.Cxx.RightShiftAssignment
import ASE.Compiler.Cxx.Sizeof
import ASE.Compiler.Cxx.Source
import ASE.Compiler.Cxx.Statement
import ASE.Compiler.Cxx.Struct
import ASE.Compiler.Cxx.StructReference
import ASE.Compiler.Cxx.Subtraction
import ASE.Compiler.Cxx.SubtractionAssignment
import ASE.Compiler.Cxx.Switch
import ASE.Compiler.Cxx.Type
import ASE.Compiler.Cxx.Typedef
import ASE.Compiler.Cxx.UnaryMinus
import ASE.Compiler.Cxx.UnaryPlus
import ASE.Compiler.Cxx.Variable
import ASE.Compiler.Cxx.While
import ASE.Compiler.Output
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Output:
  '''
  This class prints a Cxx AST to the file system as Cxx source
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.disableOutput = 0
    self.disableSource = 0
    self.roots = {}
    self.files = []
    self.f = None
    self.includes = []
    self.systemIncludes =[]
  
  def getDisableOutput(self):
    '''
    Retrieve the flag to disable writing to disk
    This is useful for generating the list of files which would have been output
    '''
    return self.disableOutput
  
  def setDisableOutput(self, disableOutput):
    '''
    Set the flag to disable writing to disk
    This is useful for generating the list of files which would have been output
    '''
    self.disableOutput = disableOutput
  
  def getDisableSource(self):
    '''
    Retrieve the flag to disable writing source
    Headers and other support files will still be output
    '''
    return self.disableSource
  
  def setDisableSource(self, disableSource):
    '''
    Set the flag to disable writing source
    Headers and other support files will still be output
    '''
    self.disableSource = disableSource
  
  def getRoot(self, purpose):
    '''
    Retrieve the directory root for files generated for the given purpose
    The purpose can be stub, cartilage, IOR, skeleton, or implementation
    '''
    return self.roots[purpose]
  
  def setRoot(self, purpose, root):
    '''
    Retrieve the directory root for files generated for the given purpose
    The purpose can be stub, cartilage, IOR, skeleton, or implementation
    '''
    self.roots[purpose] = root
  
  def getIncludeDirectories(self):
    '''
    Retrieve the list of include directories
    This seems general enough to include for all languages
    '''
    return self.includes
  
  def setIncludeDirectories(self, dirs):
    '''
    Set the list of include directories
    This seems general enough to include for all languages
    '''
    self.includes = list(dirs)
  
  def getSystemIncludeDirectories(self):
    '''
    Retrieve the list of system include directories
    This seems general enough to include for all languages
    '''
    return self.systemIncludes
  
  def setSystemIncludeDirectories(self, dirs):
    '''
    Set the list of system include directories
    This seems general enough to include for all languages
    '''
    self.systemIncludes = list(dirs)
  
  def getFiles(self):
    '''
    Retrieve the list of output files
    '''
    return self.files
  
  def setFiles(self, files):
    '''
    Set the list of output files
    '''
    self.files = list(files)
  
  def visitSource(self, vertex):
    if self.disableSource:
      return None
    import ASE.Compiler.CodePurpose
    import os
    if not os.path.splitext(vertex.getFilename())[1] == '.c':
      raise RuntimeError('A source file must have a .c extension: ' + vertex.getFilename())
    filename = os.path.join(self.getRoot(vertex.getPurpose()), vertex.getFilename())
    if not os.path.exists(os.path.dirname(filename)):
      os.makedirs(os.path.dirname(filename))
    if (not self.disableOutput) and os.path.isfile(filename) and vertex.getPurpose() == ASE.Compiler.CodePurpose.IMPLEMENTATION:
      import ASE.Compiler.ParserException
      import ASE.Compiler.Cxx.Parser
      try:
        print 'Parsing', filename
        parser = ASE.Compiler.Cxx.Parser.Parser()
        parser.setSystemIncludeDirectories(self.getSystemIncludeDirectories())
        parser.setIncludeDirectories(self.getIncludeDirectories())
        userModule = parser.parseFile(filename)
      except ASE.Compiler.ParserException:
        pass
      children = list(vertex.getChildren())
      userChildren = list(userModule.getChildren())
      userStdIncludes = self.checkStandardIncludes(children, userChildren)
      userIncludes = self.checkIncludes(children, userChildren)
      userImplStruct = self.checkImplStruct(children, userChildren)
      userSetEpvDecl = self.checkSetEpvDecl(children, userChildren)
      userMethods = self.checkMethods(children, userChildren)
      vertex.setChildren(userStdIncludes + userIncludes + userImplStruct + userSetEpvDecl + userMethods)
    print 'Creating', filename
    self.files.append(filename)
    if self.disableOutput:
      if not os.path.isfile(filename):
        raise RuntimeError('SIDL file '+filename+' has not been generated')
    else:
      self.f = file(filename, 'w')
      num = len(vertex.getChildren())
      for (c, child) in enumerate(vertex.getChildren()):
        child.accept(self.__IORself)
        if c < num - 1:
          self.__IORself.write('\n')
      self.f.close()
  
  def visitHeader(self, vertex):
    import os
    if not os.path.splitext(vertex.getFilename())[1] == '.h':
      raise RuntimeError('A header file must have a .h extension: ' + vertex.getFilename())
    filename = os.path.join(self.getRoot(vertex.getPurpose()), vertex.getFilename())
    if not os.path.exists(os.path.dirname(filename)):
      os.makedirs(os.path.dirname(filename))
    print 'Creating', filename
    self.files.append(filename)
    if self.disableOutput:
      if not os.path.isfile(filename):
        raise RuntimeError('SIDL file '+filename+' has not been generated')
    else:
      self.f = file(filename, 'w')
      num = len(vertex.getChildren())
      for (c, child) in enumerate(vertex.getChildren()):
        child.accept(self.__IORself)
        if c < num - 1:
          self.__IORself.write('\n')
      self.f.close()
  
  def visitPythonModule(self, vertex):
    if self.disableSource:
      return None
    import ASE.Compiler.CodePurpose
    import os
    klass = vertex.getClass().split('.')
    filename = apply(os.path.join, [self.getRoot(ASE.Compiler.CodePurpose.STUB)] + klass[:-1] + [klass[-1] + '.c'])
    if not os.path.exists(os.path.dirname(filename)):
      os.makedirs(os.path.dirname(filename))
    print 'Creating', filename
    self.files.append(filename)
    if self.disableOutput:
      if not os.path.isfile(filename):
        raise RuntimeError('SIDL file '+filename+' has not been generated')
    else:
      self.f = file(filename, 'w')
      num = len(vertex.getChildren())
      for (c, child) in enumerate(vertex.getChildren()):
        child.accept(self.__IORself)
        if c < num - 1:
          self.__IORself.write('\n')
      self.f.close()
  
  def write(self, s):
    '''
    This is overridden to redirect output to a file
    '''
    self.f.write(s)
  # Ending class methods section
  pass
  
  def getCodeSection(self, nodes, check):
    '''
    Returns a tuple of nodes preceeding a code block together with the code block
       - The block now consists of a single statement
       - The check function is called on each node, and should return true for termination
    '''
    prefixBlock = []
    codeBlock = []
    for node in nodes:
      if check(node):
        break
      prefixBlock.append(node)
    if len(prefixBlock) == len(nodes):
      raise RuntimeError('Missing code block')
    codeBlock.append(nodes[len(prefixBlock)])
    del nodes[:len(prefixBlock) + len(codeBlock)]
    return (prefixBlock, codeBlock)
  
  def checkStandardIncludes(self, genChildren, userChildren):
    '''
    The first section of generated children is a standard include
    '''
    
    def check(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.Include') and node.getIdentifier() == '<stdlib.h>':
        return 1
      return 0
    (genPrefix, genIncludes) = self.getCodeSection(genChildren, check)
    if len(genPrefix):
      raise RuntimeError('Invalid generated module: standard includes block cannot be preceeded by code')
    (userPrefix, userIncludes) = self.getCodeSection(userChildren, check)
    return userPrefix + genIncludes
  
  def checkIncludes(self, genChildren, userChildren):
    '''
    The section section of generated children is a guarded IOR include
    '''
    
    def check(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.PreprocessorConditional') and node.getIdentifier() == 'ifndef':
        import ASE.Compiler.Cxx.PreprocessorConditional
        if len(node.getChildren()) and node.getChildren()[0].isInstanceOf('ASE.Compiler.Cxx.Include'):
          return 1
        if ASE.Compiler.Cxx.PreprocessorConditional.PreprocessorConditional(node).getInactiveCode().startswith('# include <'):
          return 1
      return 0
    (genPrefix, genIncludes) = self.getCodeSection(genChildren, check)
    if len(genPrefix):
      raise RuntimeError('Invalid generated module: includes block cannot be preceeded by code')
    (userPrefix, userIncludes) = self.getCodeSection(userChildren, check)
    return userPrefix + genIncludes
  
  def checkImplStruct(self, genChildren, userChildren):
    '''
    The third section of generated children is the declaration of the implementation structure
    '''
    import ASE.Compiler.Cxx.Function
    includes = []
    
    def checkInclude(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.PreprocessorConditional') and node.getIdentifier() == 'ifndef':
        import ASE.Compiler.Cxx.PreprocessorConditional
        if len(node.getChildren()) and node.getChildren()[0].isInstanceOf('ASE.Compiler.Cxx.Include'):
          return 1
        if ASE.Compiler.Cxx.PreprocessorConditional.PreprocessorConditional(node).getInactiveCode().startswith('# include <'):
          return 1
      return 0
    
    def check(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.Declaration'):
        if len(node.getChildren()) == 1:
          struct = node.getChildren()[0]
          if struct.isInstanceOf('ASE.Compiler.Cxx.Struct'):
            if len(struct.getChildren()) and struct.getChildren()[0].isInstanceOf('ASE.Compiler.Cxx.Declaration'):
              decl = struct.getChildren()[0]
              if len(decl.getChildren()) and decl.getChildren()[0].getIdentifier() == 'self':
                return 1
      elif checkInclude(node):
        import ASE.Compiler.Cxx.PreprocessorConditional
        includes.append(ASE.Compiler.Cxx.PreprocessorConditional.PreprocessorConditional(node))
      return 0
    
    def checkBody(struct):
      if len(struct.getChildren()):
        if struct.getChildren()[0].isInstanceOf('ASE.Compiler.Cxx.Declaration'):
          decl = struct.getChildren()[0].getChildren()[0]
          if decl.isInstanceOf('ASE.Compiler.Cxx.Declarator') and decl.getIdentifier() == 'self':
            return 1
      return 0
    (genPrefix, genDecl) = self.getCodeSection(genChildren, check)
    genIncludes = includes[:]
    includes = []
    if len(genPrefix) != len(genIncludes):
      raise RuntimeError('Invalid generated module: implementation structure block cannot be preceeded by code')
    genStruct = genDecl[0].getChildren()[0]
    (userPrefix, userDecl) = self.getCodeSection(userChildren, check)
    userIncludes = includes[:]
    userStruct = userDecl[0].getChildren()[0]
    if not checkBody(userStruct):
      raise RuntimeError('User implementation struct must begin with the self pointer')
    if len(userStruct.getChildren()) > 1:
      genStruct.addChildren(userStruct.getChildren()[1:])
    
    def equalInclude(nodeA, nodeB):
      import ASE.Compiler.Cxx.Include
      filenames = []
      for node in [nodeA, nodeB]:
        if len(node.getChildren()):
          filenames.append(ASE.Compiler.Cxx.Include.Include(node.getChildren()[0]).getIdentifier())
        else:
          filenames.append(node.getInactiveCode().replace(' ', '')[8:])
      return filenames[0] == filenames[1]
    for inc in genIncludes:
      found = 0
      for node in userIncludes:
        if equalInclude(inc, node):
          found = 1
          break
      if not found:
        userPrefix.append(inc)
    return userPrefix + genDecl
  
  def checkSetEpvDecl(self, genChildren, userChildren):
    '''
    The fourth section of generated children is the declaration of set_epv()
    '''
    import ASE.Compiler.Cxx.Function
    
    def check(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.Declaration'):
        func = node.getChildren()[0]
        if func.isInstanceOf('ASE.Compiler.Cxx.Function'):
          name = func.getChildren()[0]
          if name.isInstanceOf('ASE.Compiler.Cxx.Declarator') and name.getIdentifier().endswith('_set_epv') and ASE.Compiler.Cxx.Function.Function(func).getBody() is None:
            return 1
      return 0
    (genPrefix, genIncludes) = self.getCodeSection(genChildren, check)
    if len(genPrefix):
      raise RuntimeError('Invalid generated module: set_epv declaration block cannot be preceeded by code')
    (userPrefix, userIncludes) = self.getCodeSection(userChildren, check)
    return userPrefix + genIncludes
  
  def checkSetEpv(self, genChildren, userChildren):
    '''
    The fourth section of generated children is the definition of set_epv()
    '''
    import ASE.Compiler.Cxx.Function
    
    def check(node):
      if node.isInstanceOf('ASE.Compiler.Cxx.Function'):
        name = node.getChildren()[0]
        if name.isInstanceOf('ASE.Compiler.Cxx.Declarator') and name.getIdentifier().endswith('_set_epv') and not ASE.Compiler.Cxx.Function.Function(node).getBody() is None:
          return 1
      return 0
    (genPrefix, genIncludes) = self.getCodeSection(genChildren, check)
    if len(genPrefix):
      raise RuntimeError('Invalid generated module: set_epv block cannot be preceeded by code')
    (userPrefix, userIncludes) = self.getCodeSection(userChildren, check)
    return userPrefix + genIncludes
  
  def checkMethods(self, genChildren, userChildren):
    '''
    The fifth section of generated children is the definition of implemented methods
    '''
    import ASE.Compiler.Cxx.CompoundStatement
    import ASE.Compiler.Cxx.Declarator
    import ASE.Compiler.Cxx.Function
    
    def check(node):
      import ASE.Compiler.Cxx.Function
      if node.isInstanceOf('ASE.Compiler.Cxx.Function'):
        name = node.getChildren()[0]
        if name.isInstanceOf('ASE.Compiler.Cxx.Declarator') and name.getIdentifier() and not ASE.Compiler.Cxx.Function.Function(node).getBody() is None:
          return 1
      return 0
    
    def checkBody(body):
      import ASE.Compiler.Cxx.Declarator
      import ASE.Compiler.Cxx.Pointer
      decls = body.getDeclarations()
      if len(decls):
        if decls[0].isInstanceOf('ASE.Compiler.Cxx.Declaration'):
          decl = ASE.Compiler.Cxx.Declarator.Declarator(decls[0].getChildren()[0])
          if decl.isInstanceOf('ASE.Compiler.Cxx.Declarator') and decl.getIdentifier() == '_obj':
            if decl.getType().isInstanceOf('ASE.Compiler.Cxx.Pointer'):
              if ASE.Compiler.Cxx.Pointer.Pointer(decl.getType()).getChildren()[0].isInstanceOf('ASE.Compiler.Cxx.Struct'):
                return 1
      return 0
    userMethods = {}

    for child in userChildren:
      if not check(child):
        raise RuntimeError('Invalid user code: Implementation must end with SIDL method defintions')
      userMethods[child.getChildren()[0].getIdentifier()] = child
    del userChildren[:]
    for child in genChildren[:-3]:
      func = ASE.Compiler.Cxx.Function.Function(child)
      body = ASE.Compiler.Cxx.CompoundStatement.CompoundStatement(func.getBody())
      name = func.getChildren()[0].getIdentifier()
      if name in userMethods:
        userFunc = ASE.Compiler.Cxx.Function.Function(userMethods[name])
        userBody = ASE.Compiler.Cxx.CompoundStatement.CompoundStatement(userFunc.getBody())
        if not checkBody(userBody):
          raise RuntimeError('Implementation method ' + name + ' must start with the object declaration')
        body.addDeclarations(userBody.getDeclarations()[1:])
        body.addChildren(userBody.getChildren())
    for child in genChildren[-3:-1]:
      func = ASE.Compiler.Cxx.Function.Function(child)
      body = ASE.Compiler.Cxx.CompoundStatement.CompoundStatement(func.getBody())
      name = func.getChildren()[0].getIdentifier()
      if name in userMethods:
        userFunc = ASE.Compiler.Cxx.Function.Function(userMethods[name])
        userBody = ASE.Compiler.Cxx.CompoundStatement.CompoundStatement(userFunc.getBody())
        body.setDeclarations(userBody.getDeclarations())
        body.setChildren(userBody.getChildren())
    return genChildren
