# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Assign
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class AugAssign:
  '''
  A Python augmented assignment
  The children are the assignment targets
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.op = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitAugAssign(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.AugAssign.AugAssign()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setOp(self.__IORself.getOp())
    return root
  
  def getOp(self):
    '''
    Retrieve the operation
    '''
    return self.op
  
  def setOp(self, op):
    '''
    Set the operation
    '''
    self.op = op
  # Ending class methods section
  pass
