# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class CallFunc:
  '''
  A Python function call
  The child is the expression for the callee
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.arguments = []
    self.optionalArguments = None
    self.keywordArguments = None
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitCallFunc(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.CallFunc.CallFunc()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setArguments([arg.copy() for arg in self.__IORself.getArguments()])
    root.setOptionalArguments([arg.copy() for arg in self.__IORself.getOptionalArguments()])
    root.setKeywordArguments([arg.copy() for arg in self.__IORself.getKeywordArguments()])
    return root
  
  def getArguments(self):
    '''
    Retrieve the arguments
    '''
    return self.arguments
  
  def setArguments(self, arguments):
    '''
    Set the arguments
    '''
    self.arguments = list(arguments)
  
  def addArguments(self, arguments):
    '''
    Add arguments
    '''
    self.arguments.extend(arguments)
  
  def removeArguments(self, arguments):
    '''
    Remove arguments
    Throws an exception if a argument does not exist
    '''
    for argument in arguments:
      if argument in self.arguments:
        self.arguments.remove(argument)
      else:
        e = ASE.Compiler.CompilerException.CompilerException()
        e.setMessage('Argument does not exist: ' + interface.getIdentifier())
        raise e
  
  def getOptionalArguments(self):
    '''
    Retrieve the optional arguments
    '''
    return self.optionalArguments
  
  def setOptionalArguments(self, optionalArguments):
    '''
    Set the optional arguments
    '''
    self.optionalArguments = optionalArguments
  
  def getKeywordArguments(self):
    '''
    Retrieve the keyword arguments
    '''
    return self.keywordArguments
  
  def setKeywordArguments(self, keywordArguments):
    '''
    Set the optional arguments
    '''
    self.keywordArguments = keywordArguments
  # Ending class methods section
  pass
