# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Compare:
  '''
  A Python comparison statement
  The child is the expression being compared to the test expression
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.testExpr = {}

  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitCompare(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Compare.Compare()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    [root.setTestExpr(op, expr.copy()) for (op, expr) in self.testExpr.items()]
    return root
  
  def getTestExpr(self, op):
    '''
    Get the test expression for the given operator
    Throws an exception if op is not present
    '''
    return self.testExpr[op]
  
  def setTestExpr(self, op, testExpr):
    '''
    Set the operations
    '''
    self.testExpr[op] = testExpr
  
  def getOps(self):
    '''
    Retrieve the operators
    '''
    return self.testExpr.keys()
  # Ending class methods section
  pass
