#include <stdlib.h>

#include <string.h>

#ifndef included_ASE_Compiler_Python_ExceptionHandler
#include "ASE/Compiler/Python/ExceptionHandler_IOR.h"
#endif

static const char *getClassName(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return strdup("ASE.Compiler.Python.ExceptionHandler");
}

#ifndef included_ASE_Loader
#include "ASE/Loader_IOR.h"
#endif

#ifndef included_ASE_ASEException
#include "ASE/ASEException_IOR.h"
#endif

static void *castObject(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ const char *name, /*out*/ struct ASE_BaseException__object **_exception)
{
  /* We are guaranteed here that the first member in any IOR is a ASE.BaseInterface object */
  struct ASE_Compiler_Python_ExceptionHandler__object *obj = ((struct ASE_BaseInterface__object *) self)->d_object;
  void *cast = NULL;
  
  if (!strcmp(name, "ASE.Compiler.Python.ExceptionHandler"))
  {
    cast = obj;
  }
  else
  if (!strcmp(name, "ASE.Compiler.Python.Vertex"))
  {
    cast = (&obj->ase_compiler_python_vertex);
  }
  else
  if (!strcmp(name, "ASE.BaseClass"))
  {
    cast = (&(&obj->ase_compiler_python_vertex)->ase_baseclass);
  }
  else
  if (!strcmp(name, "ASE.BaseInterface"))
  {
    cast = (&(&(&obj->ase_compiler_python_vertex)->ase_baseclass)->ase_baseinterface);
  }
  else
  if (!strcmp(name, "ASE.Compiler.Vertex"))
  {
    cast = (&(&obj->ase_compiler_python_vertex)->ase_compiler_vertex);
  }
  return cast;
}

static const char *strObject(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  return "ASE.Compiler.Python.ExceptionHandler";
}

static void finiObject(/*in*/ struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Vertex__object *parent = &self->ase_compiler_python_vertex;
  const struct ASE_Compiler_Python_Vertex__external *(*extFunc)(void) = (const struct ASE_Compiler_Python_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Python.Vertex", _exception);
  void (*parentFini)(/*in*/ struct ASE_Compiler_Python_Vertex__object *self, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->finiObject;
  
  self->ase_compiler_python_vertex.d_epv = self->ase_compiler_python_vertex.d_oldEpv;
  (*(self->d_epv->ExceptionHandler_))(self, _exception);
  if (!parentFini)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find finalizer for ASE.Compiler.Python.Vertex", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentFini)(parent, _exception);
}

static void destroyObject(struct ASE_Compiler_Python_ExceptionHandler__object *self, /*out*/ struct ASE_BaseException__object **_exception)
{
  finiObject(self->d_object, _exception);
  memset(self->d_object, 0, sizeof(struct ASE_Compiler_Python_ExceptionHandler__object));
  free(self->d_object);
}

static void initObject(/*in*/ struct ASE_Compiler_Python_ExceptionHandler__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_Vertex__object *parent = &self->ase_compiler_python_vertex;
  const struct ASE_Compiler_Python_Vertex__external *(*extFunc)(void) = (const struct ASE_Compiler_Python_Vertex__external *(*)(void)) ASE_Loader__externals()->getStaticEPV(_exception)->getClassMethodTable("ASE.Compiler.Python.Vertex", _exception);
  void (*parentInit)(/*in*/ struct ASE_Compiler_Python_Vertex__object *self, /*in*/ void *obj, /*out*/ struct ASE_BaseException__object **_exception) = (extFunc())->initObject;
  int epvInitialized = 0;
  static struct ASE_Compiler_Python_ExceptionHandler__epv ASE_Compiler_Python_ExceptionHandler_epv;
  static struct ASE_Compiler_Python_Vertex__epv ASE_Compiler_Python_Vertex_epv;
  static struct ASE_BaseClass__epv ASE_BaseClass_epv;
  static struct ASE_BaseInterface__epv ASE_BaseInterface_epv;
  static struct ASE_Compiler_Vertex__epv ASE_Compiler_Vertex_epv;
  
  if (!parentInit)
  {
    struct ASE_ASEException__object *_local_exception = ASE_ASEException__externals()->createObject(NULL);
    
    _local_exception->d_epv->setMessage(_local_exception, "Unable to find initializer for ASE.Compiler.Python.Vertex", _exception);
    if (!(*_exception))
    {
      *_exception = (struct ASE_BaseException__object *) _local_exception;
    }
    return;
  }
  (*parentInit)(parent, obj, _exception);
  if (!epvInitialized)
  {
    ASE_Compiler_Python_ExceptionHandler_epv.castObject = castObject;
    ASE_Compiler_Python_ExceptionHandler_epv.destroyObject = destroyObject;
    ASE_Compiler_Python_ExceptionHandler_epv.strObject = strObject;
    ASE_Compiler_Python_ExceptionHandler_epv.getClassName = getClassName;
    ASE_Compiler_Python_ExceptionHandler__set_epv(&ASE_Compiler_Python_ExceptionHandler_epv, _exception);
    /* Override class ASE.Compiler.Python.ExceptionHandler methods with those of superclass ASE.Compiler.Python.Vertex */
    ASE_Compiler_Python_ExceptionHandler_epv.clone = self->ase_compiler_python_vertex.d_epv->clone;
    ASE_Compiler_Python_ExceptionHandler_epv.accept = self->ase_compiler_python_vertex.d_epv->accept;
    ASE_Compiler_Python_ExceptionHandler_epv.getIdentifier = self->ase_compiler_python_vertex.d_epv->getIdentifier;
    ASE_Compiler_Python_ExceptionHandler_epv.setIdentifier = self->ase_compiler_python_vertex.d_epv->setIdentifier;
    ASE_Compiler_Python_ExceptionHandler_epv.getAttributes = self->ase_compiler_python_vertex.d_epv->getAttributes;
    ASE_Compiler_Python_ExceptionHandler_epv.setAttributes = self->ase_compiler_python_vertex.d_epv->setAttributes;
    ASE_Compiler_Python_ExceptionHandler_epv.hasAttribute = self->ase_compiler_python_vertex.d_epv->hasAttribute;
    ASE_Compiler_Python_ExceptionHandler_epv.addAttribute = self->ase_compiler_python_vertex.d_epv->addAttribute;
    ASE_Compiler_Python_ExceptionHandler_epv.deleteAttribute = self->ase_compiler_python_vertex.d_epv->deleteAttribute;
    ASE_Compiler_Python_ExceptionHandler_epv.getAttribute = self->ase_compiler_python_vertex.d_epv->getAttribute;
    ASE_Compiler_Python_ExceptionHandler_epv.getParent = self->ase_compiler_python_vertex.d_epv->getParent;
    ASE_Compiler_Python_ExceptionHandler_epv.setParent = self->ase_compiler_python_vertex.d_epv->setParent;
    ASE_Compiler_Python_ExceptionHandler_epv.getChildren = self->ase_compiler_python_vertex.d_epv->getChildren;
    ASE_Compiler_Python_ExceptionHandler_epv.setChildren = self->ase_compiler_python_vertex.d_epv->setChildren;
    ASE_Compiler_Python_ExceptionHandler_epv.addChildren = self->ase_compiler_python_vertex.d_epv->addChildren;
    ASE_Compiler_Python_ExceptionHandler_epv.removeChildren = self->ase_compiler_python_vertex.d_epv->removeChildren;
    ASE_Compiler_Python_ExceptionHandler_epv.getLineNumber = self->ase_compiler_python_vertex.d_epv->getLineNumber;
    ASE_Compiler_Python_ExceptionHandler_epv.setLineNumber = self->ase_compiler_python_vertex.d_epv->setLineNumber;
    ASE_Compiler_Python_ExceptionHandler_epv.getComments = self->ase_compiler_python_vertex.d_epv->getComments;
    ASE_Compiler_Python_ExceptionHandler_epv.setComments = self->ase_compiler_python_vertex.d_epv->setComments;
    ASE_Compiler_Python_ExceptionHandler_epv.addComments = self->ase_compiler_python_vertex.d_epv->addComments;
    ASE_Compiler_Python_ExceptionHandler_epv.removeComments = self->ase_compiler_python_vertex.d_epv->removeComments;
    ASE_Compiler_Python_ExceptionHandler_epv.getReferenceCount = self->ase_compiler_python_vertex.d_epv->getReferenceCount;
    ASE_Compiler_Python_ExceptionHandler_epv.addReference = self->ase_compiler_python_vertex.d_epv->addReference;
    ASE_Compiler_Python_ExceptionHandler_epv.deleteReference = self->ase_compiler_python_vertex.d_epv->deleteReference;
    ASE_Compiler_Python_ExceptionHandler_epv.isSame = self->ase_compiler_python_vertex.d_epv->isSame;
    ASE_Compiler_Python_ExceptionHandler_epv.getClassName = self->ase_compiler_python_vertex.d_epv->getClassName;
    ASE_Compiler_Python_ExceptionHandler_epv.getName = self->ase_compiler_python_vertex.d_epv->getName;
    ASE_Compiler_Python_ExceptionHandler_epv.setName = self->ase_compiler_python_vertex.d_epv->setName;
    ASE_Compiler_Python_ExceptionHandler_epv.isInstanceOf = self->ase_compiler_python_vertex.d_epv->isInstanceOf;
    ASE_Compiler_Python_ExceptionHandler_epv.getSuper = self->ase_compiler_python_vertex.d_epv->getSuper;
    ASE_Compiler_Python_ExceptionHandler_epv.copy = self->ase_compiler_python_vertex.d_epv->copy;
    /* Virtualize superclass ASE.Compiler.Python.Vertex methods with those of class ASE.Compiler.Python.ExceptionHandler */
    ASE_Compiler_Python_Vertex_epv.castObject = ASE_Compiler_Python_ExceptionHandler_epv.castObject;
    ASE_Compiler_Python_Vertex_epv.destroyObject = ASE_Compiler_Python_ExceptionHandler_epv.destroyObject;
    ASE_Compiler_Python_Vertex_epv.strObject = ASE_Compiler_Python_ExceptionHandler_epv.strObject;
    ASE_Compiler_Python_Vertex_epv.clone = ASE_Compiler_Python_ExceptionHandler_epv.clone;
    ASE_Compiler_Python_Vertex_epv.accept = ASE_Compiler_Python_ExceptionHandler_epv.accept;
    ASE_Compiler_Python_Vertex_epv.getIdentifier = ASE_Compiler_Python_ExceptionHandler_epv.getIdentifier;
    ASE_Compiler_Python_Vertex_epv.setIdentifier = ASE_Compiler_Python_ExceptionHandler_epv.setIdentifier;
    ASE_Compiler_Python_Vertex_epv.getAttributes = ASE_Compiler_Python_ExceptionHandler_epv.getAttributes;
    ASE_Compiler_Python_Vertex_epv.setAttributes = ASE_Compiler_Python_ExceptionHandler_epv.setAttributes;
    ASE_Compiler_Python_Vertex_epv.hasAttribute = ASE_Compiler_Python_ExceptionHandler_epv.hasAttribute;
    ASE_Compiler_Python_Vertex_epv.addAttribute = ASE_Compiler_Python_ExceptionHandler_epv.addAttribute;
    ASE_Compiler_Python_Vertex_epv.deleteAttribute = ASE_Compiler_Python_ExceptionHandler_epv.deleteAttribute;
    ASE_Compiler_Python_Vertex_epv.getAttribute = ASE_Compiler_Python_ExceptionHandler_epv.getAttribute;
    ASE_Compiler_Python_Vertex_epv.getParent = ASE_Compiler_Python_ExceptionHandler_epv.getParent;
    ASE_Compiler_Python_Vertex_epv.setParent = ASE_Compiler_Python_ExceptionHandler_epv.setParent;
    ASE_Compiler_Python_Vertex_epv.getChildren = ASE_Compiler_Python_ExceptionHandler_epv.getChildren;
    ASE_Compiler_Python_Vertex_epv.setChildren = ASE_Compiler_Python_ExceptionHandler_epv.setChildren;
    ASE_Compiler_Python_Vertex_epv.addChildren = ASE_Compiler_Python_ExceptionHandler_epv.addChildren;
    ASE_Compiler_Python_Vertex_epv.removeChildren = ASE_Compiler_Python_ExceptionHandler_epv.removeChildren;
    ASE_Compiler_Python_Vertex_epv.getLineNumber = ASE_Compiler_Python_ExceptionHandler_epv.getLineNumber;
    ASE_Compiler_Python_Vertex_epv.setLineNumber = ASE_Compiler_Python_ExceptionHandler_epv.setLineNumber;
    ASE_Compiler_Python_Vertex_epv.getComments = ASE_Compiler_Python_ExceptionHandler_epv.getComments;
    ASE_Compiler_Python_Vertex_epv.setComments = ASE_Compiler_Python_ExceptionHandler_epv.setComments;
    ASE_Compiler_Python_Vertex_epv.addComments = ASE_Compiler_Python_ExceptionHandler_epv.addComments;
    ASE_Compiler_Python_Vertex_epv.removeComments = ASE_Compiler_Python_ExceptionHandler_epv.removeComments;
    ASE_Compiler_Python_Vertex_epv.getReferenceCount = ASE_Compiler_Python_ExceptionHandler_epv.getReferenceCount;
    ASE_Compiler_Python_Vertex_epv.addReference = ASE_Compiler_Python_ExceptionHandler_epv.addReference;
    ASE_Compiler_Python_Vertex_epv.deleteReference = ASE_Compiler_Python_ExceptionHandler_epv.deleteReference;
    ASE_Compiler_Python_Vertex_epv.isSame = ASE_Compiler_Python_ExceptionHandler_epv.isSame;
    ASE_Compiler_Python_Vertex_epv.getClassName = ASE_Compiler_Python_ExceptionHandler_epv.getClassName;
    ASE_Compiler_Python_Vertex_epv.getName = ASE_Compiler_Python_ExceptionHandler_epv.getName;
    ASE_Compiler_Python_Vertex_epv.setName = ASE_Compiler_Python_ExceptionHandler_epv.setName;
    ASE_Compiler_Python_Vertex_epv.isInstanceOf = ASE_Compiler_Python_ExceptionHandler_epv.isInstanceOf;
    ASE_Compiler_Python_Vertex_epv.getSuper = ASE_Compiler_Python_ExceptionHandler_epv.getSuper;
    ASE_Compiler_Python_Vertex_epv.copy = ASE_Compiler_Python_ExceptionHandler_epv.copy;
    /* Override class ASE.Compiler.Python.Vertex methods with those of superclass ASE.BaseClass */
    ASE_Compiler_Python_Vertex_epv.getReferenceCount = self->ase_compiler_python_vertex.ase_baseclass.d_epv->getReferenceCount;
    ASE_Compiler_Python_Vertex_epv.addReference = self->ase_compiler_python_vertex.ase_baseclass.d_epv->addReference;
    ASE_Compiler_Python_Vertex_epv.deleteReference = self->ase_compiler_python_vertex.ase_baseclass.d_epv->deleteReference;
    ASE_Compiler_Python_Vertex_epv.isSame = self->ase_compiler_python_vertex.ase_baseclass.d_epv->isSame;
    ASE_Compiler_Python_Vertex_epv.getClassName = self->ase_compiler_python_vertex.ase_baseclass.d_epv->getClassName;
    ASE_Compiler_Python_Vertex_epv.getName = self->ase_compiler_python_vertex.ase_baseclass.d_epv->getName;
    ASE_Compiler_Python_Vertex_epv.setName = self->ase_compiler_python_vertex.ase_baseclass.d_epv->setName;
    ASE_Compiler_Python_Vertex_epv.isInstanceOf = self->ase_compiler_python_vertex.ase_baseclass.d_epv->isInstanceOf;
    ASE_Compiler_Python_Vertex_epv.getSuper = self->ase_compiler_python_vertex.ase_baseclass.d_epv->getSuper;
    /* Virtualize superclass ASE.BaseClass methods with those of class ASE.Compiler.Python.Vertex */
    ASE_BaseClass_epv.castObject = ASE_Compiler_Python_Vertex_epv.castObject;
    ASE_BaseClass_epv.destroyObject = ASE_Compiler_Python_Vertex_epv.destroyObject;
    ASE_BaseClass_epv.strObject = ASE_Compiler_Python_Vertex_epv.strObject;
    ASE_BaseClass_epv.getReferenceCount = ASE_Compiler_Python_Vertex_epv.getReferenceCount;
    ASE_BaseClass_epv.addReference = ASE_Compiler_Python_Vertex_epv.addReference;
    ASE_BaseClass_epv.deleteReference = ASE_Compiler_Python_Vertex_epv.deleteReference;
    ASE_BaseClass_epv.isSame = ASE_Compiler_Python_Vertex_epv.isSame;
    ASE_BaseClass_epv.getClassName = ASE_Compiler_Python_Vertex_epv.getClassName;
    ASE_BaseClass_epv.getName = ASE_Compiler_Python_Vertex_epv.getName;
    ASE_BaseClass_epv.setName = ASE_Compiler_Python_Vertex_epv.setName;
    ASE_BaseClass_epv.isInstanceOf = ASE_Compiler_Python_Vertex_epv.isInstanceOf;
    ASE_BaseClass_epv.getSuper = ASE_Compiler_Python_Vertex_epv.getSuper;
    /* Initialize interface ASE.Compiler.Vertex methods with those of class ASE.Compiler.Python.Vertex */
    ASE_Compiler_Vertex_epv.castObject = ASE_Compiler_Python_Vertex_epv.castObject;
    ASE_Compiler_Vertex_epv.destroyObject = ASE_Compiler_Python_Vertex_epv.destroyObject;
    ASE_Compiler_Vertex_epv.strObject = ASE_Compiler_Python_Vertex_epv.strObject;
    ASE_Compiler_Vertex_epv.getReferenceCount = ASE_Compiler_Python_Vertex_epv.getReferenceCount;
    ASE_Compiler_Vertex_epv.addReference = ASE_Compiler_Python_Vertex_epv.addReference;
    ASE_Compiler_Vertex_epv.deleteReference = ASE_Compiler_Python_Vertex_epv.deleteReference;
    ASE_Compiler_Vertex_epv.isSame = ASE_Compiler_Python_Vertex_epv.isSame;
    ASE_Compiler_Vertex_epv.getClassName = ASE_Compiler_Python_Vertex_epv.getClassName;
    ASE_Compiler_Vertex_epv.getName = ASE_Compiler_Python_Vertex_epv.getName;
    ASE_Compiler_Vertex_epv.setName = ASE_Compiler_Python_Vertex_epv.setName;
    ASE_Compiler_Vertex_epv.isInstanceOf = ASE_Compiler_Python_Vertex_epv.isInstanceOf;
    ASE_Compiler_Vertex_epv.getSuper = ASE_Compiler_Python_Vertex_epv.getSuper;
    ASE_Compiler_Vertex_epv.clone = ASE_Compiler_Python_Vertex_epv.clone;
    ASE_Compiler_Vertex_epv.copy = ASE_Compiler_Python_Vertex_epv.copy;
    ASE_Compiler_Vertex_epv.accept = ASE_Compiler_Python_Vertex_epv.accept;
    ASE_Compiler_Vertex_epv.getIdentifier = ASE_Compiler_Python_Vertex_epv.getIdentifier;
    ASE_Compiler_Vertex_epv.setIdentifier = ASE_Compiler_Python_Vertex_epv.setIdentifier;
    ASE_Compiler_Vertex_epv.getAttributes = ASE_Compiler_Python_Vertex_epv.getAttributes;
    ASE_Compiler_Vertex_epv.setAttributes = ASE_Compiler_Python_Vertex_epv.setAttributes;
    ASE_Compiler_Vertex_epv.hasAttribute = ASE_Compiler_Python_Vertex_epv.hasAttribute;
    ASE_Compiler_Vertex_epv.addAttribute = ASE_Compiler_Python_Vertex_epv.addAttribute;
    ASE_Compiler_Vertex_epv.deleteAttribute = ASE_Compiler_Python_Vertex_epv.deleteAttribute;
    ASE_Compiler_Vertex_epv.getAttribute = ASE_Compiler_Python_Vertex_epv.getAttribute;
    ASE_Compiler_Vertex_epv.getParent = ASE_Compiler_Python_Vertex_epv.getParent;
    ASE_Compiler_Vertex_epv.setParent = ASE_Compiler_Python_Vertex_epv.setParent;
    ASE_Compiler_Vertex_epv.getChildren = ASE_Compiler_Python_Vertex_epv.getChildren;
    ASE_Compiler_Vertex_epv.setChildren = ASE_Compiler_Python_Vertex_epv.setChildren;
    ASE_Compiler_Vertex_epv.addChildren = ASE_Compiler_Python_Vertex_epv.addChildren;
    ASE_Compiler_Vertex_epv.removeChildren = ASE_Compiler_Python_Vertex_epv.removeChildren;
    ASE_Compiler_Vertex_epv.getLineNumber = ASE_Compiler_Python_Vertex_epv.getLineNumber;
    ASE_Compiler_Vertex_epv.setLineNumber = ASE_Compiler_Python_Vertex_epv.setLineNumber;
    ASE_Compiler_Vertex_epv.getComments = ASE_Compiler_Python_Vertex_epv.getComments;
    ASE_Compiler_Vertex_epv.setComments = ASE_Compiler_Python_Vertex_epv.setComments;
    ASE_Compiler_Vertex_epv.addComments = ASE_Compiler_Python_Vertex_epv.addComments;
    ASE_Compiler_Vertex_epv.removeComments = ASE_Compiler_Python_Vertex_epv.removeComments;
    /* Initialize interface ASE.BaseInterface methods with those of class ASE.Compiler.Python.Vertex */
    ASE_BaseInterface_epv.castObject = ASE_Compiler_Python_Vertex_epv.castObject;
    ASE_BaseInterface_epv.destroyObject = ASE_Compiler_Python_Vertex_epv.destroyObject;
    ASE_BaseInterface_epv.strObject = ASE_Compiler_Python_Vertex_epv.strObject;
    ASE_BaseInterface_epv.getReferenceCount = ASE_Compiler_Python_Vertex_epv.getReferenceCount;
    ASE_BaseInterface_epv.addReference = ASE_Compiler_Python_Vertex_epv.addReference;
    ASE_BaseInterface_epv.deleteReference = ASE_Compiler_Python_Vertex_epv.deleteReference;
    ASE_BaseInterface_epv.isSame = ASE_Compiler_Python_Vertex_epv.isSame;
    ASE_BaseInterface_epv.getClassName = ASE_Compiler_Python_Vertex_epv.getClassName;
    ASE_BaseInterface_epv.getName = ASE_Compiler_Python_Vertex_epv.getName;
    ASE_BaseInterface_epv.setName = ASE_Compiler_Python_Vertex_epv.setName;
    ASE_BaseInterface_epv.isInstanceOf = ASE_Compiler_Python_Vertex_epv.isInstanceOf;
    ASE_BaseInterface_epv.getSuper = ASE_Compiler_Python_Vertex_epv.getSuper;
    epvInitialized = 1;
  }
  self->ase_compiler_python_vertex.ase_baseclass.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_vertex.ase_baseclass.d_epv = &ASE_BaseClass_epv;
  self->ase_compiler_python_vertex.ase_compiler_vertex.ase_baseinterface.d_epv = &ASE_BaseInterface_epv;
  self->ase_compiler_python_vertex.ase_compiler_vertex.d_epv = &ASE_Compiler_Vertex_epv;
  self->ase_compiler_python_vertex.d_epv = &ASE_Compiler_Python_Vertex_epv;
  self->d_epv = &ASE_Compiler_Python_ExceptionHandler_epv;
  /* Save old EPV for getSuper() */
  self->d_oldEpv = self->d_epv;
  /* Initialize pointers to the original object */
  self->d_object = obj;
  /* Setup implementation data */
  self->d_data = NULL;
  (*(self->d_epv->ExceptionHandler))(self, _exception);
}

static struct ASE_Compiler_Python_ExceptionHandler__object *createObject(/*out*/ struct ASE_BaseException__object **_exception)
{
  struct ASE_Compiler_Python_ExceptionHandler__object *self = (struct ASE_Compiler_Python_ExceptionHandler__object *) malloc(sizeof(struct ASE_Compiler_Python_ExceptionHandler__object));
  
  initObject(self, self, _exception);
  return self;
}

/* The entry points into the DLL containing this type */
static struct ASE_Compiler_Python_ExceptionHandler__external externalEntryPoints = {
  createObject,
  initObject,
  finiObject,
  createArray,
  borrowArray,
  destroyArray,
  getDimen,
  getLower,
  getUpper,
  getElement,
  getElement4,
  setElement,
  setElement4};

const struct ASE_Compiler_Python_ExceptionHandler__external *ASE_Compiler_Python_ExceptionHandler__externals(void)
{
  return &externalEntryPoints;
}
