# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.Python.Flags
import ASE.Compiler.Python.Vertex
import ASE.Compiler.Python.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Function:
  '''
  A Python function, bound or unbound
  The children of this node constitue the body of the function
  Default values are not yet supported
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.argumentNames = []
    self.defaults = []
    self.flags = None
  
  def getFlags(self):
    '''
    Retrieve the flags
    '''
    return self.flags
  
  def setFlags(self, flags):
    '''
    Set the flags
    '''
    self.flags = flags
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitFunction(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.Cxx.Function.Function()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setArgumentNames([name for name in self.__IORself.getArgumentsNames()])
    root.setDefaults([default.copy() for default in self.__IORself.getDefaults()])
    return root
  
  def getArgumentNames(self):
    '''
    Retrieve the argument names
    '''
    return self.argumentNames
  
  def setArgumentNames(self, argumentNames):
    '''
    Set the argument names
    '''
    self.argumentNames = argumentNames
  
  def getDefaults(self):
    '''
    Retrieve the default argument values
    '''
    return self.defaults
  
  def setDefaults(self, defaults):
    '''
    Set the default argument values
    '''
    self.defaults = list(defaults)
  # Ending class methods section
  pass
