class SIDL(object):
  def __init__(self):
    self.typeMap = self.createTypeMap()
    return

  def createTypeMap(self):
    import ASE.Compiler.SIDL.Type

    typeMap = {}
    for typeName in ['bool', 'char', 'dcomplex', 'double', 'fcomplex', 'float', 'int', 'long', 'opaque', 'string', 'void']:
      sidlType = ASE.Compiler.SIDL.Type.Type()
      sidlType.setIdentifier(typeName)
      sidlType.setBaseType(1)
      typeMap[typeName] = sidlType
    return typeMap

  def getLoader(self, interface):
    for child in self.getBaseInterface(interface).getParent().getChildren():
      if child.getIdentifier() == 'Loader':
        import ASE.Compiler.SIDL.Class
        return ASE.Compiler.SIDL.Class.Class(child)
    raise RuntimeError('Could not find Loader using '+interface.getFullIdentifier())

  def getBasePackage(self, interface):
    import ASE.Compiler.SIDL.Package
    return ASE.Compiler.SIDL.Package.Package(self.getAncestor(interface, 'ASE.BaseInterface').getParent())

  def getBaseInterface(self, interface):
    return self.getAncestor(interface, 'ASE.BaseInterface')

  def getBaseException(self, exception):
    return self.getAncestor(exception, 'ASE.BaseException')

  def getASEException(self, interface):
    asePackage = self.getBasePackage(interface)
    for child in asePackage.getChildren():
      if child.getIdentifier() == 'ASEException':
        import ASE.Compiler.SIDL.Class
        return ASE.Compiler.SIDL.Class.Class(child)
    return None

  def getAncestor(self, interface, typeName):
    import ASE.Compiler.SIDL.Interface
    interface = ASE.Compiler.SIDL.Interface.Interface(interface)
    if interface.getFullIdentifier() == typeName:
      return interface
    parents = []
    if interface.isInstanceOf('ASE.Compiler.SIDL.Class'):
      import ASE.Compiler.SIDL.Class
      parents.extend(ASE.Compiler.SIDL.Class.Class(interface).getInterfaces())
    parents.extend(interface.getParents())
    for parent in parents:
      base = self.getAncestor(parent, typeName)
      if base:
        return base
    return None
