# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.ParameterAccessMode
import ASE.Compiler.SIDL.Type
import ASE.Compiler.SIDL.Vertex
import ASE.Compiler.SIDL.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Parameter:
  '''
  A SIDL method parameter
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.type = None
    self.accessMode = ASE.Compiler.ParameterAccessMode.IN
    self.isRequired = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitParameter(self.__IORself)
  
  def getType(self):
    '''
    Retrieve the parameter type
    '''
    return self.type
  
  def setType(self, type):
    '''
    Set the parameter type
    '''
    if type.isInstanceOf('ASE.Compiler.SIDL.Interface'):
      type = type.weakReference()
    self.type = type
  
  def getAccessMode(self):
    '''
    Retrieve the access mode
    '''
    return self.accessMode
  
  def setAccessMode(self, mode):
    '''
    Set the access mode
    '''
    self.accessMode = mode
  
  def getRequired(self):
    '''
    Retrieve the flag indicating whether the parameter is required in a call
    '''
    return self.isRequired
  
  def setRequired(self, isRequired):
    '''
    Set the flag indicating whether the parameter is required in a call
    '''
    self.isRequired = isRequired
  # Ending class methods section
  pass
