# Starting imports section
pass
import ASE.BaseException
import ASE.BaseInterface
import ASE.Compiler.Attribute
import ASE.Compiler.Comment
import ASE.Compiler.CompilerException
import ASE.Compiler.SIDL.Vertex
import ASE.Compiler.SIDL.Visitor
import ASE.Compiler.Vertex
# Ending imports section
pass
# Starting static methods section
pass
# Ending static methods section
pass

class Type:
  '''
  Any SIDL type
  '''
  # Starting class methods section
  pass
  
  def __init__(self, IORself):
    self.__IORself = IORself
    self.baseType = 0
  
  def accept(self, visitor):
    '''
    Overridden to dispatch correctly
    '''
    visitor.visitType(self.__IORself)
  
  def copy(self):
    '''
    Need to override this
    '''
    root = ASE.Compiler.SIDL.Type.Type()
    root.setIdentifier(self.__IORself.getIdentifier())
    root.setAttributes(self.__IORself.getAttributes())
    root.setLineNumber(self.__IORself.getLineNumber())
    root.setComments(self.__IORself.getComments())
    root.setChildren([child.copy() for child in self.__IORself.getChildren()])
    root.setBaseType(self.__IORself.getBaseType())
    return root
  
  def getFullIdentifier(self):
    '''
    Need to override this to calculate the fully qualified type name
    '''
    id = self.__IORself.getIdentifier()
    parent = self.__IORself.getParent()
    if not self.getBaseType() and not parent is None:
      return ASE.Compiler.SIDL.Vertex.Vertex(parent).getFullIdentifier() + '.' + id
    return id
  
  def getBaseType(self):
    '''
    Get flag indicating whether this is a base type
    '''
    return self.baseType
  
  def setBaseType(self, baseType):
    '''
    Set flag indicating whether this is a base type
    '''
    self.baseType = baseType
  # Ending class methods section
  pass
